/* page-view.c generated by valac 0.40.19, the Vala compiler
 * generated from page-view.vala, do not modify */

/*
 * Copyright (C) 2009-2015 Canonical Ltd.
 * Author: Robert Ancell <robert.ancell@canonical.com>
 *
 * This program is free software: you can redistribute it and/or modify it under
 * the terms of the GNU General Public License as published by the Free Software
 * Foundation, either version 3 of the License, or (at your option) any later
 * version. See http://www.gnu.org/copyleft/gpl.html the full text of the
 * license.
 */


#include <glib.h>
#include <glib-object.h>
#include <gdk-pixbuf/gdk-pixbuf.h>
#include <float.h>
#include <math.h>
#include <gdk/gdk.h>
#include <string.h>
#include <stdlib.h>
#include <cairo.h>

typedef enum  {
	CROP_LOCATION_NONE = 0,
	CROP_LOCATION_MIDDLE,
	CROP_LOCATION_TOP,
	CROP_LOCATION_BOTTOM,
	CROP_LOCATION_LEFT,
	CROP_LOCATION_RIGHT,
	CROP_LOCATION_TOP_LEFT,
	CROP_LOCATION_TOP_RIGHT,
	CROP_LOCATION_BOTTOM_LEFT,
	CROP_LOCATION_BOTTOM_RIGHT
} CropLocation;


#define TYPE_CROP_LOCATION (crop_location_get_type ())

#define TYPE_PAGE_VIEW (page_view_get_type ())
#define PAGE_VIEW(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_PAGE_VIEW, PageView))
#define PAGE_VIEW_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TYPE_PAGE_VIEW, PageViewClass))
#define IS_PAGE_VIEW(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_PAGE_VIEW))
#define IS_PAGE_VIEW_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TYPE_PAGE_VIEW))
#define PAGE_VIEW_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TYPE_PAGE_VIEW, PageViewClass))

typedef struct _PageView PageView;
typedef struct _PageViewClass PageViewClass;
typedef struct _PageViewPrivate PageViewPrivate;

#define TYPE_PAGE (page_get_type ())
#define PAGE(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_PAGE, Page))
#define PAGE_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TYPE_PAGE, PageClass))
#define IS_PAGE(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_PAGE))
#define IS_PAGE_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TYPE_PAGE))
#define PAGE_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TYPE_PAGE, PageClass))

typedef struct _Page Page;
typedef struct _PageClass PageClass;
typedef enum  {
	SCAN_DIRECTION_TOP_TO_BOTTOM,
	SCAN_DIRECTION_LEFT_TO_RIGHT,
	SCAN_DIRECTION_BOTTOM_TO_TOP,
	SCAN_DIRECTION_RIGHT_TO_LEFT
} ScanDirection;


#define TYPE_SCAN_DIRECTION (scan_direction_get_type ())
enum  {
	PAGE_VIEW_0_PROPERTY,
	PAGE_VIEW_PAGE_PROPERTY,
	PAGE_VIEW_SELECTED_PROPERTY,
	PAGE_VIEW_X_OFFSET_PROPERTY,
	PAGE_VIEW_Y_OFFSET_PROPERTY,
	PAGE_VIEW_CURSOR_PROPERTY,
	PAGE_VIEW_WIDTH_PROPERTY,
	PAGE_VIEW_HEIGHT_PROPERTY,
	PAGE_VIEW_NUM_PROPERTIES
};
static GParamSpec* page_view_properties[PAGE_VIEW_NUM_PROPERTIES];
#define _g_object_unref0(var) ((var == NULL) ? NULL : (var = (g_object_unref (var), NULL)))
#define _g_free0(var) (var = (g_free (var), NULL))
enum  {
	PAGE_VIEW_SIZE_CHANGED_SIGNAL,
	PAGE_VIEW_CHANGED_SIGNAL,
	PAGE_VIEW_NUM_SIGNALS
};
static guint page_view_signals[PAGE_VIEW_NUM_SIGNALS] = {0};

struct _PageView {
	GObject parent_instance;
	PageViewPrivate * priv;
};

struct _PageViewClass {
	GObjectClass parent_class;
};

struct _PageViewPrivate {
	Page* _page;
	GdkPixbuf* image;
	gboolean selected_;
	gint ruler_width;
	gint border_width;
	gboolean update_image;
	ScanDirection scan_direction;
	gint scan_line;
	gint width_;
	gint height_;
	gint _x_offset;
	gint _y_offset;
	CropLocation crop_location;
	gdouble selected_crop_px;
	gdouble selected_crop_py;
	gint selected_crop_x;
	gint selected_crop_y;
	gint selected_crop_w;
	gint selected_crop_h;
	GdkCursorType _cursor;
	gint animate_n_segments;
	gint animate_segment;
	guint animate_timeout;
};


static gpointer page_view_parent_class = NULL;

GType crop_location_get_type (void) G_GNUC_CONST;
GType page_view_get_type (void) G_GNUC_CONST;
GType page_get_type (void) G_GNUC_CONST;
GType scan_direction_get_type (void) G_GNUC_CONST;
#define PAGE_VIEW_GET_PRIVATE(o) (G_TYPE_INSTANCE_GET_PRIVATE ((o), TYPE_PAGE_VIEW, PageViewPrivate))
Page* page_view_get_page (PageView* self);
static void page_view_page_pixels_changed_cb (PageView* self,
                                       Page* p);
static void _page_view_page_pixels_changed_cb_page_pixels_changed (Page* _sender,
                                                            gpointer self);
static void page_view_page_size_changed_cb (PageView* self,
                                     Page* p);
static void _page_view_page_size_changed_cb_page_size_changed (Page* _sender,
                                                        gpointer self);
static void page_view_page_overlay_changed_cb (PageView* self,
                                        Page* p);
static void _page_view_page_overlay_changed_cb_page_crop_changed (Page* _sender,
                                                           gpointer self);
static void _page_view_page_overlay_changed_cb_page_scan_line_changed (Page* _sender,
                                                                gpointer self);
static void page_view_scan_direction_changed_cb (PageView* self,
                                          Page* p);
static void _page_view_scan_direction_changed_cb_page_scan_direction_changed (Page* _sender,
                                                                       gpointer self);
PageView* page_view_new (Page* page);
PageView* page_view_construct (GType object_type,
                               Page* page);
static void page_view_set_page (PageView* self,
                         Page* value);
static guchar page_view_get_sample (PageView* self,
                             guchar* pixels,
                             int pixels_length1,
                             gint offset,
                             gint x,
                             gint depth,
                             gint sample);
static void page_view_get_pixel (PageView* self,
                          Page* page,
                          gint x,
                          gint y,
                          guchar* pixel,
                          int pixel_length1);
ScanDirection page_get_scan_direction (Page* self);
gint page_get_scan_width (Page* self);
gint page_get_scan_height (Page* self);
gint page_get_depth (Page* self);
gint page_get_n_channels (Page* self);
guchar* page_get_pixels (Page* self,
                         int* result_length1);
gint page_get_rowstride (Page* self);
static void page_view_set_pixel (PageView* self,
                          Page* page,
                          gdouble l,
                          gdouble r,
                          gdouble t,
                          gdouble b,
                          guchar* output,
                          int output_length1,
                          gint offset);
static void page_view_update_preview (PageView* self,
                               Page* page,
                               GdkPixbuf* * output_image,
                               gint output_width,
                               gint output_height,
                               ScanDirection scan_direction,
                               gint old_scan_line,
                               gint scan_line);
gint page_get_width (Page* self);
gint page_get_height (Page* self);
gboolean page_get_has_data (Page* self);
static gint page_view_get_preview_width (PageView* self);
static gint page_view_get_preview_height (PageView* self);
static void page_view_update_page_view (PageView* self);
gint page_get_scan_line (Page* self);
static gint page_view_page_to_screen_x (PageView* self,
                                 gint x);
static gint page_view_page_to_screen_y (PageView* self,
                                 gint y);
static gint page_view_screen_to_page_x (PageView* self,
                                 gint x);
static gint page_view_screen_to_page_y (PageView* self,
                                 gint y);
static CropLocation page_view_get_crop_location (PageView* self,
                                          gint x,
                                          gint y);
gboolean page_get_has_crop (Page* self);
gint page_get_crop_x (Page* self);
gint page_get_crop_y (Page* self);
gint page_get_crop_width (Page* self);
gint page_get_crop_height (Page* self);
const gchar* page_get_crop_name (Page* self);
void page_view_button_press (PageView* self,
                             gint x,
                             gint y);
void page_view_motion (PageView* self,
                       gint x,
                       gint y);
static void page_view_set_cursor (PageView* self,
                           GdkCursorType value);
void page_move_crop (Page* self,
                     gint x,
                     gint y);
void page_set_custom_crop (Page* self,
                           gint width,
                           gint height);
void page_view_button_release (PageView* self,
                               gint x,
                               gint y);
static gboolean page_view_animation_cb (PageView* self);
static void page_view_update_animation (PageView* self);
gboolean page_get_is_scanning (Page* self);
static gboolean _page_view_animation_cb_gsource_func (gpointer self);
void page_view_render (PageView* self,
                       cairo_t* context);
gint page_view_get_x_offset (PageView* self);
gint page_view_get_y_offset (PageView* self);
gint page_get_dpi (Page* self);
gboolean page_view_get_selected (PageView* self);
void page_view_set_selected (PageView* self,
                             gboolean value);
void page_view_set_x_offset (PageView* self,
                             gint value);
void page_view_set_y_offset (PageView* self,
                             gint value);
GdkCursorType page_view_get_cursor (PageView* self);
gint page_view_get_width (PageView* self);
void page_view_set_width (PageView* self,
                          gint value);
gint page_view_get_height (PageView* self);
void page_view_set_height (PageView* self,
                           gint value);
static void page_view_finalize (GObject * obj);
static void _vala_page_view_get_property (GObject * object,
                                   guint property_id,
                                   GValue * value,
                                   GParamSpec * pspec);
static void _vala_page_view_set_property (GObject * object,
                                   guint property_id,
                                   const GValue * value,
                                   GParamSpec * pspec);


GType
crop_location_get_type (void)
{
	static volatile gsize crop_location_type_id__volatile = 0;
	if (g_once_init_enter (&crop_location_type_id__volatile)) {
		static const GEnumValue values[] = {{CROP_LOCATION_NONE, "CROP_LOCATION_NONE", "none"}, {CROP_LOCATION_MIDDLE, "CROP_LOCATION_MIDDLE", "middle"}, {CROP_LOCATION_TOP, "CROP_LOCATION_TOP", "top"}, {CROP_LOCATION_BOTTOM, "CROP_LOCATION_BOTTOM", "bottom"}, {CROP_LOCATION_LEFT, "CROP_LOCATION_LEFT", "left"}, {CROP_LOCATION_RIGHT, "CROP_LOCATION_RIGHT", "right"}, {CROP_LOCATION_TOP_LEFT, "CROP_LOCATION_TOP_LEFT", "top-left"}, {CROP_LOCATION_TOP_RIGHT, "CROP_LOCATION_TOP_RIGHT", "top-right"}, {CROP_LOCATION_BOTTOM_LEFT, "CROP_LOCATION_BOTTOM_LEFT", "bottom-left"}, {CROP_LOCATION_BOTTOM_RIGHT, "CROP_LOCATION_BOTTOM_RIGHT", "bottom-right"}, {0, NULL, NULL}};
		GType crop_location_type_id;
		crop_location_type_id = g_enum_register_static ("CropLocation", values);
		g_once_init_leave (&crop_location_type_id__volatile, crop_location_type_id);
	}
	return crop_location_type_id__volatile;
}


static void
_page_view_page_pixels_changed_cb_page_pixels_changed (Page* _sender,
                                                       gpointer self)
{
	page_view_page_pixels_changed_cb ((PageView*) self, _sender);
}


static void
_page_view_page_size_changed_cb_page_size_changed (Page* _sender,
                                                   gpointer self)
{
	page_view_page_size_changed_cb ((PageView*) self, _sender);
}


static void
_page_view_page_overlay_changed_cb_page_crop_changed (Page* _sender,
                                                      gpointer self)
{
	page_view_page_overlay_changed_cb ((PageView*) self, _sender);
}


static void
_page_view_page_overlay_changed_cb_page_scan_line_changed (Page* _sender,
                                                           gpointer self)
{
	page_view_page_overlay_changed_cb ((PageView*) self, _sender);
}


static void
_page_view_scan_direction_changed_cb_page_scan_direction_changed (Page* _sender,
                                                                  gpointer self)
{
	page_view_scan_direction_changed_cb ((PageView*) self, _sender);
}


PageView*
page_view_construct (GType object_type,
                     Page* page)
{
	PageView * self = NULL;
	g_return_val_if_fail (page != NULL, NULL);
	self = (PageView*) g_object_new (object_type, NULL);
	page_view_set_page (self, page);
	g_signal_connect_object (page, "pixels-changed", (GCallback) _page_view_page_pixels_changed_cb_page_pixels_changed, self, 0);
	g_signal_connect_object (page, "size-changed", (GCallback) _page_view_page_size_changed_cb_page_size_changed, self, 0);
	g_signal_connect_object (page, "crop-changed", (GCallback) _page_view_page_overlay_changed_cb_page_crop_changed, self, 0);
	g_signal_connect_object (page, "scan-line-changed", (GCallback) _page_view_page_overlay_changed_cb_page_scan_line_changed, self, 0);
	g_signal_connect_object (page, "scan-direction-changed", (GCallback) _page_view_scan_direction_changed_cb_page_scan_direction_changed, self, 0);
	return self;
}


PageView*
page_view_new (Page* page)
{
	return page_view_construct (TYPE_PAGE_VIEW, page);
}


static guchar
page_view_get_sample (PageView* self,
                      guchar* pixels,
                      int pixels_length1,
                      gint offset,
                      gint x,
                      gint depth,
                      gint sample)
{
	guchar result = '\0';
	g_return_val_if_fail (self != NULL, '\0');
	result = (guchar) 0xFF;
	return result;
}


static void
page_view_get_pixel (PageView* self,
                     Page* page,
                     gint x,
                     gint y,
                     guchar* pixel,
                     int pixel_length1)
{
	ScanDirection _tmp0_;
	ScanDirection _tmp1_;
	gint depth = 0;
	gint _tmp12_;
	gint _tmp13_;
	gint n_channels = 0;
	gint _tmp14_;
	gint _tmp15_;
	guchar* pixels = NULL;
	gint _tmp16_ = 0;
	guchar* _tmp17_;
	gint pixels_length1;
	gint _pixels_size_;
	gint offset = 0;
	gint _tmp18_;
	gint _tmp19_;
	gboolean _tmp20_ = FALSE;
	gint _tmp21_;
	guchar* _tmp59_;
	gint _tmp59__length1;
	gint _tmp60_;
	gint _tmp61_;
	gint _tmp62_;
	guchar* _tmp63_;
	gint _tmp63__length1;
	gint _tmp64_;
	gint _tmp65_;
	gint _tmp66_;
	guchar* _tmp67_;
	gint _tmp67__length1;
	gint _tmp68_;
	gint _tmp69_;
	gint _tmp70_;
	g_return_if_fail (self != NULL);
	g_return_if_fail (page != NULL);
	_tmp0_ = page_get_scan_direction (page);
	_tmp1_ = _tmp0_;
	switch (_tmp1_) {
		case SCAN_DIRECTION_TOP_TO_BOTTOM:
		{
			break;
		}
		case SCAN_DIRECTION_BOTTOM_TO_TOP:
		{
			gint _tmp2_;
			gint _tmp3_;
			gint _tmp4_;
			gint _tmp5_;
			_tmp2_ = page_get_scan_width (page);
			_tmp3_ = _tmp2_;
			x = (_tmp3_ - x) - 1;
			_tmp4_ = page_get_scan_height (page);
			_tmp5_ = _tmp4_;
			y = (_tmp5_ - y) - 1;
			break;
		}
		case SCAN_DIRECTION_LEFT_TO_RIGHT:
		{
			gint t = 0;
			gint _tmp6_;
			gint _tmp7_;
			gint _tmp8_;
			t = x;
			_tmp6_ = page_get_scan_width (page);
			_tmp7_ = _tmp6_;
			x = (_tmp7_ - y) - 1;
			_tmp8_ = t;
			y = _tmp8_;
			break;
		}
		case SCAN_DIRECTION_RIGHT_TO_LEFT:
		{
			gint t = 0;
			gint _tmp9_;
			gint _tmp10_;
			gint _tmp11_;
			t = x;
			x = y;
			_tmp9_ = page_get_scan_height (page);
			_tmp10_ = _tmp9_;
			_tmp11_ = t;
			y = (_tmp10_ - _tmp11_) - 1;
			break;
		}
		default:
		break;
	}
	_tmp12_ = page_get_depth (page);
	_tmp13_ = _tmp12_;
	depth = _tmp13_;
	_tmp14_ = page_get_n_channels (page);
	_tmp15_ = _tmp14_;
	n_channels = _tmp15_;
	_tmp17_ = page_get_pixels (page, &_tmp16_);
	pixels = _tmp17_;
	pixels_length1 = _tmp16_;
	_pixels_size_ = pixels_length1;
	_tmp18_ = page_get_rowstride (page);
	_tmp19_ = _tmp18_;
	offset = _tmp19_ * y;
	_tmp21_ = depth;
	if (_tmp21_ == 8) {
		gint _tmp22_;
		_tmp22_ = n_channels;
		_tmp20_ = _tmp22_ == 3;
	} else {
		_tmp20_ = FALSE;
	}
	if (_tmp20_) {
		gint o = 0;
		gint _tmp23_;
		gint _tmp24_;
		guchar* _tmp25_;
		gint _tmp25__length1;
		gint _tmp26_;
		guchar _tmp27_;
		guchar* _tmp28_;
		gint _tmp28__length1;
		gint _tmp29_;
		guchar _tmp30_;
		guchar* _tmp31_;
		gint _tmp31__length1;
		gint _tmp32_;
		guchar _tmp33_;
		_tmp23_ = offset;
		_tmp24_ = n_channels;
		o = _tmp23_ + (x * _tmp24_);
		_tmp25_ = pixels;
		_tmp25__length1 = pixels_length1;
		_tmp26_ = o;
		_tmp27_ = _tmp25_[_tmp26_];
		pixel[0] = _tmp27_;
		_tmp28_ = pixels;
		_tmp28__length1 = pixels_length1;
		_tmp29_ = o;
		_tmp30_ = _tmp28_[_tmp29_ + 1];
		pixel[1] = _tmp30_;
		_tmp31_ = pixels;
		_tmp31__length1 = pixels_length1;
		_tmp32_ = o;
		_tmp33_ = _tmp31_[_tmp32_ + 2];
		pixel[2] = _tmp33_;
		return;
	} else {
		gboolean _tmp34_ = FALSE;
		gint _tmp35_;
		_tmp35_ = depth;
		if (_tmp35_ == 8) {
			gint _tmp36_;
			_tmp36_ = n_channels;
			_tmp34_ = _tmp36_ == 1;
		} else {
			_tmp34_ = FALSE;
		}
		if (_tmp34_) {
			guchar* _tmp37_;
			gint _tmp37__length1;
			gint _tmp38_;
			guchar _tmp39_;
			_tmp37_ = pixels;
			_tmp37__length1 = pixels_length1;
			_tmp38_ = offset;
			_tmp39_ = _tmp37_[_tmp38_ + x];
			pixel[2] = _tmp39_;
			pixel[1] = pixel[2];
			pixel[0] = pixel[1];
			return;
		} else {
			gboolean _tmp40_ = FALSE;
			gint _tmp41_;
			_tmp41_ = depth;
			if (_tmp41_ == 1) {
				gint _tmp42_;
				_tmp42_ = n_channels;
				_tmp40_ = _tmp42_ == 1;
			} else {
				_tmp40_ = FALSE;
			}
			if (_tmp40_) {
				gint o = 0;
				gint _tmp43_;
				gint _tmp44_ = 0;
				guchar* _tmp45_;
				gint _tmp45__length1;
				gint _tmp46_;
				guchar _tmp47_;
				_tmp43_ = offset;
				o = _tmp43_ + (x / 8);
				_tmp45_ = pixels;
				_tmp45__length1 = pixels_length1;
				_tmp46_ = o;
				_tmp47_ = _tmp45_[_tmp46_];
				if (((gint) (_tmp47_ & (0x80 >> (x % 8)))) != 0) {
					_tmp44_ = 0x00;
				} else {
					_tmp44_ = 0xFF;
				}
				pixel[2] = (guchar) _tmp44_;
				pixel[1] = pixel[2];
				pixel[0] = pixel[1];
				return;
			} else {
				gboolean _tmp48_ = FALSE;
				gint _tmp49_;
				_tmp49_ = depth;
				if (_tmp49_ == 2) {
					gint _tmp50_;
					_tmp50_ = n_channels;
					_tmp48_ = _tmp50_ == 1;
				} else {
					_tmp48_ = FALSE;
				}
				if (_tmp48_) {
					gint block_shift[4] = {0};
					gint _tmp51_[4] = {0};
					gint o = 0;
					gint _tmp52_;
					gint sample = 0;
					guchar* _tmp53_;
					gint _tmp53__length1;
					gint _tmp54_;
					guchar _tmp55_;
					gint _tmp56_;
					gint _tmp57_;
					gint _tmp58_;
					_tmp51_[0] = 6;
					_tmp51_[1] = 4;
					_tmp51_[2] = 2;
					_tmp51_[3] = 0;
					memcpy (block_shift, _tmp51_, 4 * sizeof (gint));
					_tmp52_ = offset;
					o = _tmp52_ + (x / 4);
					_tmp53_ = pixels;
					_tmp53__length1 = pixels_length1;
					_tmp54_ = o;
					_tmp55_ = _tmp53_[_tmp54_];
					_tmp56_ = block_shift[x % 4];
					sample = (_tmp55_ >> _tmp56_) & 0x3;
					_tmp57_ = sample;
					sample = (_tmp57_ * 255) / 3;
					_tmp58_ = sample;
					pixel[2] = (guchar) _tmp58_;
					pixel[1] = pixel[2];
					pixel[0] = pixel[1];
					return;
				}
			}
		}
	}
	_tmp59_ = pixels;
	_tmp59__length1 = pixels_length1;
	_tmp60_ = offset;
	_tmp61_ = depth;
	_tmp62_ = n_channels;
	pixel[0] = page_view_get_sample (self, _tmp59_, _tmp59__length1, _tmp60_, x, _tmp61_, x * _tmp62_);
	_tmp63_ = pixels;
	_tmp63__length1 = pixels_length1;
	_tmp64_ = offset;
	_tmp65_ = depth;
	_tmp66_ = n_channels;
	pixel[1] = page_view_get_sample (self, _tmp63_, _tmp63__length1, _tmp64_, x, _tmp65_, (x * _tmp66_) + 1);
	_tmp67_ = pixels;
	_tmp67__length1 = pixels_length1;
	_tmp68_ = offset;
	_tmp69_ = depth;
	_tmp70_ = n_channels;
	pixel[2] = page_view_get_sample (self, _tmp67_, _tmp67__length1, _tmp68_, x, _tmp69_, (x * _tmp70_) + 2);
}


static void
page_view_set_pixel (PageView* self,
                     Page* page,
                     gdouble l,
                     gdouble r,
                     gdouble t,
                     gdouble b,
                     guchar* output,
                     int output_length1,
                     gint offset)
{
	gint L = 0;
	gint _tmp0_;
	gint R = 0;
	gint T = 0;
	gint _tmp2_;
	gint B = 0;
	gdouble red = 0.0;
	gdouble green = 0.0;
	gdouble blue = 0.0;
	gboolean _tmp4_ = FALSE;
	gboolean _tmp5_ = FALSE;
	gboolean _tmp165_ = FALSE;
	gint _tmp166_;
	gboolean _tmp182_ = FALSE;
	gint _tmp183_;
	gboolean _tmp199_ = FALSE;
	gint _tmp200_;
	gboolean _tmp216_ = FALSE;
	gint _tmp217_;
	gdouble scale = 0.0;
	gdouble _tmp233_;
	gdouble _tmp234_;
	gdouble _tmp235_;
	gdouble _tmp236_;
	gdouble _tmp237_;
	gdouble _tmp238_;
	g_return_if_fail (self != NULL);
	g_return_if_fail (page != NULL);
	L = (gint) l;
	_tmp0_ = L;
	if (((gdouble) _tmp0_) != l) {
		gint _tmp1_;
		_tmp1_ = L;
		L = _tmp1_ + 1;
	}
	R = (gint) r;
	T = (gint) t;
	_tmp2_ = T;
	if (((gdouble) _tmp2_) != t) {
		gint _tmp3_;
		_tmp3_ = T;
		T = _tmp3_ + 1;
	}
	B = (gint) b;
	red = 0.0;
	green = 0.0;
	blue = 0.0;
	if ((r - l) <= 1.0) {
		_tmp5_ = ((gint) r) == ((gint) l);
	} else {
		_tmp5_ = FALSE;
	}
	if (_tmp5_) {
		_tmp4_ = TRUE;
	} else {
		gboolean _tmp6_ = FALSE;
		if ((b - t) <= 1.0) {
			_tmp6_ = ((gint) b) == ((gint) t);
		} else {
			_tmp6_ = FALSE;
		}
		_tmp4_ = _tmp6_;
	}
	if (_tmp4_) {
		gboolean _tmp7_ = FALSE;
		gint _tmp11_;
		gint _tmp12_;
		gdouble scale = 0.0;
		gdouble _tmp83_;
		gdouble _tmp84_;
		gdouble _tmp85_;
		gdouble _tmp86_;
		gdouble _tmp87_;
		gdouble _tmp88_;
		if (((gint) l) == ((gint) r)) {
			_tmp7_ = TRUE;
		} else {
			_tmp7_ = ((gint) t) == ((gint) b);
		}
		if (_tmp7_) {
			guchar p[3] = {0};
			guchar _tmp8_;
			guchar _tmp9_;
			guchar _tmp10_;
			page_view_get_pixel (self, page, (gint) l, (gint) t, p, 3);
			_tmp8_ = p[0];
			output[offset] = _tmp8_;
			_tmp9_ = p[1];
			output[offset + 1] = _tmp9_;
			_tmp10_ = p[2];
			output[offset + 2] = _tmp10_;
			return;
		}
		_tmp11_ = L;
		_tmp12_ = R;
		if (_tmp11_ > _tmp12_) {
			guchar p[3] = {0};
			gint _tmp13_;
			gint _tmp14_;
			gdouble _tmp15_;
			guchar _tmp16_;
			gint _tmp17_;
			gdouble _tmp18_;
			guchar _tmp19_;
			gint _tmp20_;
			gdouble _tmp21_;
			guchar _tmp22_;
			gint _tmp23_;
			gint _tmp37_;
			gint _tmp38_;
			gdouble _tmp39_;
			guchar _tmp40_;
			gint _tmp41_;
			gdouble _tmp42_;
			guchar _tmp43_;
			gint _tmp44_;
			gdouble _tmp45_;
			guchar _tmp46_;
			gint _tmp47_;
			_tmp13_ = R;
			_tmp14_ = T;
			page_view_get_pixel (self, page, _tmp13_, _tmp14_ - 1, p, 3);
			_tmp15_ = red;
			_tmp16_ = p[0];
			_tmp17_ = T;
			red = _tmp15_ + ((_tmp16_ * (r - l)) * (_tmp17_ - t));
			_tmp18_ = green;
			_tmp19_ = p[1];
			_tmp20_ = T;
			green = _tmp18_ + ((_tmp19_ * (r - l)) * (_tmp20_ - t));
			_tmp21_ = blue;
			_tmp22_ = p[2];
			_tmp23_ = T;
			blue = _tmp21_ + ((_tmp22_ * (r - l)) * (_tmp23_ - t));
			{
				gint y = 0;
				gint _tmp24_;
				_tmp24_ = T;
				y = _tmp24_;
				{
					gboolean _tmp25_ = FALSE;
					_tmp25_ = TRUE;
					while (TRUE) {
						gint _tmp27_;
						gint _tmp28_;
						gint _tmp29_;
						gint _tmp30_;
						gdouble _tmp31_;
						guchar _tmp32_;
						gdouble _tmp33_;
						guchar _tmp34_;
						gdouble _tmp35_;
						guchar _tmp36_;
						if (!_tmp25_) {
							gint _tmp26_;
							_tmp26_ = y;
							y = _tmp26_ + 1;
						}
						_tmp25_ = FALSE;
						_tmp27_ = y;
						_tmp28_ = B;
						if (!(_tmp27_ < _tmp28_)) {
							break;
						}
						_tmp29_ = R;
						_tmp30_ = y;
						page_view_get_pixel (self, page, _tmp29_, _tmp30_, p, 3);
						_tmp31_ = red;
						_tmp32_ = p[0];
						red = _tmp31_ + (_tmp32_ * (r - l));
						_tmp33_ = green;
						_tmp34_ = p[1];
						green = _tmp33_ + (_tmp34_ * (r - l));
						_tmp35_ = blue;
						_tmp36_ = p[2];
						blue = _tmp35_ + (_tmp36_ * (r - l));
					}
				}
			}
			_tmp37_ = R;
			_tmp38_ = B;
			page_view_get_pixel (self, page, _tmp37_, _tmp38_, p, 3);
			_tmp39_ = red;
			_tmp40_ = p[0];
			_tmp41_ = B;
			red = _tmp39_ + ((_tmp40_ * (r - l)) * (b - _tmp41_));
			_tmp42_ = green;
			_tmp43_ = p[1];
			_tmp44_ = B;
			green = _tmp42_ + ((_tmp43_ * (r - l)) * (b - _tmp44_));
			_tmp45_ = blue;
			_tmp46_ = p[2];
			_tmp47_ = B;
			blue = _tmp45_ + ((_tmp46_ * (r - l)) * (b - _tmp47_));
		} else {
			guchar p[3] = {0};
			gint _tmp48_;
			gint _tmp49_;
			gdouble _tmp50_;
			guchar _tmp51_;
			gint _tmp52_;
			gdouble _tmp53_;
			guchar _tmp54_;
			gint _tmp55_;
			gdouble _tmp56_;
			guchar _tmp57_;
			gint _tmp58_;
			gint _tmp72_;
			gint _tmp73_;
			gdouble _tmp74_;
			guchar _tmp75_;
			gint _tmp76_;
			gdouble _tmp77_;
			guchar _tmp78_;
			gint _tmp79_;
			gdouble _tmp80_;
			guchar _tmp81_;
			gint _tmp82_;
			_tmp48_ = L;
			_tmp49_ = B;
			page_view_get_pixel (self, page, _tmp48_ - 1, _tmp49_, p, 3);
			_tmp50_ = red;
			_tmp51_ = p[0];
			_tmp52_ = L;
			red = _tmp50_ + ((_tmp51_ * (b - t)) * (_tmp52_ - l));
			_tmp53_ = green;
			_tmp54_ = p[1];
			_tmp55_ = L;
			green = _tmp53_ + ((_tmp54_ * (b - t)) * (_tmp55_ - l));
			_tmp56_ = blue;
			_tmp57_ = p[2];
			_tmp58_ = L;
			blue = _tmp56_ + ((_tmp57_ * (b - t)) * (_tmp58_ - l));
			{
				gint x = 0;
				gint _tmp59_;
				_tmp59_ = L;
				x = _tmp59_;
				{
					gboolean _tmp60_ = FALSE;
					_tmp60_ = TRUE;
					while (TRUE) {
						gint _tmp62_;
						gint _tmp63_;
						gint _tmp64_;
						gint _tmp65_;
						gdouble _tmp66_;
						guchar _tmp67_;
						gdouble _tmp68_;
						guchar _tmp69_;
						gdouble _tmp70_;
						guchar _tmp71_;
						if (!_tmp60_) {
							gint _tmp61_;
							_tmp61_ = x;
							x = _tmp61_ + 1;
						}
						_tmp60_ = FALSE;
						_tmp62_ = x;
						_tmp63_ = R;
						if (!(_tmp62_ < _tmp63_)) {
							break;
						}
						_tmp64_ = x;
						_tmp65_ = B;
						page_view_get_pixel (self, page, _tmp64_, _tmp65_, p, 3);
						_tmp66_ = red;
						_tmp67_ = p[0];
						red = _tmp66_ + (_tmp67_ * (b - t));
						_tmp68_ = green;
						_tmp69_ = p[1];
						green = _tmp68_ + (_tmp69_ * (b - t));
						_tmp70_ = blue;
						_tmp71_ = p[2];
						blue = _tmp70_ + (_tmp71_ * (b - t));
					}
				}
			}
			_tmp72_ = R;
			_tmp73_ = B;
			page_view_get_pixel (self, page, _tmp72_, _tmp73_, p, 3);
			_tmp74_ = red;
			_tmp75_ = p[0];
			_tmp76_ = R;
			red = _tmp74_ + ((_tmp75_ * (b - t)) * (r - _tmp76_));
			_tmp77_ = green;
			_tmp78_ = p[1];
			_tmp79_ = R;
			green = _tmp77_ + ((_tmp78_ * (b - t)) * (r - _tmp79_));
			_tmp80_ = blue;
			_tmp81_ = p[2];
			_tmp82_ = R;
			blue = _tmp80_ + ((_tmp81_ * (b - t)) * (r - _tmp82_));
		}
		scale = 1.0 / ((r - l) * (b - t));
		_tmp83_ = red;
		_tmp84_ = scale;
		output[offset] = (guchar) ((_tmp83_ * _tmp84_) + 0.5);
		_tmp85_ = green;
		_tmp86_ = scale;
		output[offset + 1] = (guchar) ((_tmp85_ * _tmp86_) + 0.5);
		_tmp87_ = blue;
		_tmp88_ = scale;
		output[offset + 2] = (guchar) ((_tmp87_ * _tmp88_) + 0.5);
		return;
	}
	{
		gint x = 0;
		gint _tmp89_;
		_tmp89_ = L;
		x = _tmp89_;
		{
			gboolean _tmp90_ = FALSE;
			_tmp90_ = TRUE;
			while (TRUE) {
				gint _tmp92_;
				gint _tmp93_;
				if (!_tmp90_) {
					gint _tmp91_;
					_tmp91_ = x;
					x = _tmp91_ + 1;
				}
				_tmp90_ = FALSE;
				_tmp92_ = x;
				_tmp93_ = R;
				if (!(_tmp92_ < _tmp93_)) {
					break;
				}
				{
					gint y = 0;
					gint _tmp94_;
					_tmp94_ = T;
					y = _tmp94_;
					{
						gboolean _tmp95_ = FALSE;
						_tmp95_ = TRUE;
						while (TRUE) {
							gint _tmp97_;
							gint _tmp98_;
							guchar p[3] = {0};
							gint _tmp99_;
							gint _tmp100_;
							gdouble _tmp101_;
							guchar _tmp102_;
							gdouble _tmp103_;
							guchar _tmp104_;
							gdouble _tmp105_;
							guchar _tmp106_;
							if (!_tmp95_) {
								gint _tmp96_;
								_tmp96_ = y;
								y = _tmp96_ + 1;
							}
							_tmp95_ = FALSE;
							_tmp97_ = y;
							_tmp98_ = B;
							if (!(_tmp97_ < _tmp98_)) {
								break;
							}
							_tmp99_ = x;
							_tmp100_ = y;
							page_view_get_pixel (self, page, _tmp99_, _tmp100_, p, 3);
							_tmp101_ = red;
							_tmp102_ = p[0];
							red = _tmp101_ + _tmp102_;
							_tmp103_ = green;
							_tmp104_ = p[1];
							green = _tmp103_ + _tmp104_;
							_tmp105_ = blue;
							_tmp106_ = p[2];
							blue = _tmp105_ + _tmp106_;
						}
					}
				}
			}
		}
	}
	{
		gint x = 0;
		gint _tmp107_;
		_tmp107_ = L;
		x = _tmp107_;
		{
			gboolean _tmp108_ = FALSE;
			_tmp108_ = TRUE;
			while (TRUE) {
				gint _tmp110_;
				gint _tmp111_;
				gint _tmp112_;
				gint _tmp124_;
				if (!_tmp108_) {
					gint _tmp109_;
					_tmp109_ = x;
					x = _tmp109_ + 1;
				}
				_tmp108_ = FALSE;
				_tmp110_ = x;
				_tmp111_ = R;
				if (!(_tmp110_ < _tmp111_)) {
					break;
				}
				_tmp112_ = T;
				if (t != ((gdouble) _tmp112_)) {
					guchar p[3] = {0};
					gint _tmp113_;
					gint _tmp114_;
					gdouble _tmp115_;
					guchar _tmp116_;
					gint _tmp117_;
					gdouble _tmp118_;
					guchar _tmp119_;
					gint _tmp120_;
					gdouble _tmp121_;
					guchar _tmp122_;
					gint _tmp123_;
					_tmp113_ = x;
					_tmp114_ = T;
					page_view_get_pixel (self, page, _tmp113_, _tmp114_ - 1, p, 3);
					_tmp115_ = red;
					_tmp116_ = p[0];
					_tmp117_ = T;
					red = _tmp115_ + (_tmp116_ * (_tmp117_ - t));
					_tmp118_ = green;
					_tmp119_ = p[1];
					_tmp120_ = T;
					green = _tmp118_ + (_tmp119_ * (_tmp120_ - t));
					_tmp121_ = blue;
					_tmp122_ = p[2];
					_tmp123_ = T;
					blue = _tmp121_ + (_tmp122_ * (_tmp123_ - t));
				}
				_tmp124_ = B;
				if (b != ((gdouble) _tmp124_)) {
					guchar p[3] = {0};
					gint _tmp125_;
					gint _tmp126_;
					gdouble _tmp127_;
					guchar _tmp128_;
					gint _tmp129_;
					gdouble _tmp130_;
					guchar _tmp131_;
					gint _tmp132_;
					gdouble _tmp133_;
					guchar _tmp134_;
					gint _tmp135_;
					_tmp125_ = x;
					_tmp126_ = B;
					page_view_get_pixel (self, page, _tmp125_, _tmp126_, p, 3);
					_tmp127_ = red;
					_tmp128_ = p[0];
					_tmp129_ = B;
					red = _tmp127_ + (_tmp128_ * (b - _tmp129_));
					_tmp130_ = green;
					_tmp131_ = p[1];
					_tmp132_ = B;
					green = _tmp130_ + (_tmp131_ * (b - _tmp132_));
					_tmp133_ = blue;
					_tmp134_ = p[2];
					_tmp135_ = B;
					blue = _tmp133_ + (_tmp134_ * (b - _tmp135_));
				}
			}
		}
	}
	{
		gint y = 0;
		gint _tmp136_;
		_tmp136_ = T;
		y = _tmp136_;
		{
			gboolean _tmp137_ = FALSE;
			_tmp137_ = TRUE;
			while (TRUE) {
				gint _tmp139_;
				gint _tmp140_;
				gint _tmp141_;
				gint _tmp153_;
				if (!_tmp137_) {
					gint _tmp138_;
					_tmp138_ = y;
					y = _tmp138_ + 1;
				}
				_tmp137_ = FALSE;
				_tmp139_ = y;
				_tmp140_ = B;
				if (!(_tmp139_ < _tmp140_)) {
					break;
				}
				_tmp141_ = L;
				if (l != ((gdouble) _tmp141_)) {
					guchar p[3] = {0};
					gint _tmp142_;
					gint _tmp143_;
					gdouble _tmp144_;
					guchar _tmp145_;
					gint _tmp146_;
					gdouble _tmp147_;
					guchar _tmp148_;
					gint _tmp149_;
					gdouble _tmp150_;
					guchar _tmp151_;
					gint _tmp152_;
					_tmp142_ = L;
					_tmp143_ = y;
					page_view_get_pixel (self, page, _tmp142_ - 1, _tmp143_, p, 3);
					_tmp144_ = red;
					_tmp145_ = p[0];
					_tmp146_ = L;
					red = _tmp144_ + (_tmp145_ * (_tmp146_ - l));
					_tmp147_ = green;
					_tmp148_ = p[1];
					_tmp149_ = L;
					green = _tmp147_ + (_tmp148_ * (_tmp149_ - l));
					_tmp150_ = blue;
					_tmp151_ = p[2];
					_tmp152_ = L;
					blue = _tmp150_ + (_tmp151_ * (_tmp152_ - l));
				}
				_tmp153_ = R;
				if (r != ((gdouble) _tmp153_)) {
					guchar p[3] = {0};
					gint _tmp154_;
					gint _tmp155_;
					gdouble _tmp156_;
					guchar _tmp157_;
					gint _tmp158_;
					gdouble _tmp159_;
					guchar _tmp160_;
					gint _tmp161_;
					gdouble _tmp162_;
					guchar _tmp163_;
					gint _tmp164_;
					_tmp154_ = R;
					_tmp155_ = y;
					page_view_get_pixel (self, page, _tmp154_, _tmp155_, p, 3);
					_tmp156_ = red;
					_tmp157_ = p[0];
					_tmp158_ = R;
					red = _tmp156_ + (_tmp157_ * (r - _tmp158_));
					_tmp159_ = green;
					_tmp160_ = p[1];
					_tmp161_ = R;
					green = _tmp159_ + (_tmp160_ * (r - _tmp161_));
					_tmp162_ = blue;
					_tmp163_ = p[2];
					_tmp164_ = R;
					blue = _tmp162_ + (_tmp163_ * (r - _tmp164_));
				}
			}
		}
	}
	_tmp166_ = L;
	if (l != ((gdouble) _tmp166_)) {
		gint _tmp167_;
		_tmp167_ = T;
		_tmp165_ = t != ((gdouble) _tmp167_);
	} else {
		_tmp165_ = FALSE;
	}
	if (_tmp165_) {
		guchar p[3] = {0};
		gint _tmp168_;
		gint _tmp169_;
		gdouble _tmp170_;
		guchar _tmp171_;
		gint _tmp172_;
		gint _tmp173_;
		gdouble _tmp174_;
		guchar _tmp175_;
		gint _tmp176_;
		gint _tmp177_;
		gdouble _tmp178_;
		guchar _tmp179_;
		gint _tmp180_;
		gint _tmp181_;
		_tmp168_ = L;
		_tmp169_ = T;
		page_view_get_pixel (self, page, _tmp168_ - 1, _tmp169_ - 1, p, 3);
		_tmp170_ = red;
		_tmp171_ = p[0];
		_tmp172_ = L;
		_tmp173_ = T;
		red = _tmp170_ + ((_tmp171_ * (_tmp172_ - l)) * (_tmp173_ - t));
		_tmp174_ = green;
		_tmp175_ = p[1];
		_tmp176_ = L;
		_tmp177_ = T;
		green = _tmp174_ + ((_tmp175_ * (_tmp176_ - l)) * (_tmp177_ - t));
		_tmp178_ = blue;
		_tmp179_ = p[2];
		_tmp180_ = L;
		_tmp181_ = T;
		blue = _tmp178_ + ((_tmp179_ * (_tmp180_ - l)) * (_tmp181_ - t));
	}
	_tmp183_ = R;
	if (r != ((gdouble) _tmp183_)) {
		gint _tmp184_;
		_tmp184_ = T;
		_tmp182_ = t != ((gdouble) _tmp184_);
	} else {
		_tmp182_ = FALSE;
	}
	if (_tmp182_) {
		guchar p[3] = {0};
		gint _tmp185_;
		gint _tmp186_;
		gdouble _tmp187_;
		guchar _tmp188_;
		gint _tmp189_;
		gint _tmp190_;
		gdouble _tmp191_;
		guchar _tmp192_;
		gint _tmp193_;
		gint _tmp194_;
		gdouble _tmp195_;
		guchar _tmp196_;
		gint _tmp197_;
		gint _tmp198_;
		_tmp185_ = R;
		_tmp186_ = T;
		page_view_get_pixel (self, page, _tmp185_, _tmp186_ - 1, p, 3);
		_tmp187_ = red;
		_tmp188_ = p[0];
		_tmp189_ = R;
		_tmp190_ = T;
		red = _tmp187_ + ((_tmp188_ * (r - _tmp189_)) * (_tmp190_ - t));
		_tmp191_ = green;
		_tmp192_ = p[1];
		_tmp193_ = R;
		_tmp194_ = T;
		green = _tmp191_ + ((_tmp192_ * (r - _tmp193_)) * (_tmp194_ - t));
		_tmp195_ = blue;
		_tmp196_ = p[2];
		_tmp197_ = R;
		_tmp198_ = T;
		blue = _tmp195_ + ((_tmp196_ * (r - _tmp197_)) * (_tmp198_ - t));
	}
	_tmp200_ = R;
	if (r != ((gdouble) _tmp200_)) {
		gint _tmp201_;
		_tmp201_ = B;
		_tmp199_ = b != ((gdouble) _tmp201_);
	} else {
		_tmp199_ = FALSE;
	}
	if (_tmp199_) {
		guchar p[3] = {0};
		gint _tmp202_;
		gint _tmp203_;
		gdouble _tmp204_;
		guchar _tmp205_;
		gint _tmp206_;
		gint _tmp207_;
		gdouble _tmp208_;
		guchar _tmp209_;
		gint _tmp210_;
		gint _tmp211_;
		gdouble _tmp212_;
		guchar _tmp213_;
		gint _tmp214_;
		gint _tmp215_;
		_tmp202_ = R;
		_tmp203_ = B;
		page_view_get_pixel (self, page, _tmp202_, _tmp203_, p, 3);
		_tmp204_ = red;
		_tmp205_ = p[0];
		_tmp206_ = R;
		_tmp207_ = B;
		red = _tmp204_ + ((_tmp205_ * (r - _tmp206_)) * (b - _tmp207_));
		_tmp208_ = green;
		_tmp209_ = p[1];
		_tmp210_ = R;
		_tmp211_ = B;
		green = _tmp208_ + ((_tmp209_ * (r - _tmp210_)) * (b - _tmp211_));
		_tmp212_ = blue;
		_tmp213_ = p[2];
		_tmp214_ = R;
		_tmp215_ = B;
		blue = _tmp212_ + ((_tmp213_ * (r - _tmp214_)) * (b - _tmp215_));
	}
	_tmp217_ = L;
	if (l != ((gdouble) _tmp217_)) {
		gint _tmp218_;
		_tmp218_ = B;
		_tmp216_ = b != ((gdouble) _tmp218_);
	} else {
		_tmp216_ = FALSE;
	}
	if (_tmp216_) {
		guchar p[3] = {0};
		gint _tmp219_;
		gint _tmp220_;
		gdouble _tmp221_;
		guchar _tmp222_;
		gint _tmp223_;
		gint _tmp224_;
		gdouble _tmp225_;
		guchar _tmp226_;
		gint _tmp227_;
		gint _tmp228_;
		gdouble _tmp229_;
		guchar _tmp230_;
		gint _tmp231_;
		gint _tmp232_;
		_tmp219_ = L;
		_tmp220_ = B;
		page_view_get_pixel (self, page, _tmp219_ - 1, _tmp220_, p, 3);
		_tmp221_ = red;
		_tmp222_ = p[0];
		_tmp223_ = L;
		_tmp224_ = B;
		red = _tmp221_ + ((_tmp222_ * (_tmp223_ - l)) * (b - _tmp224_));
		_tmp225_ = green;
		_tmp226_ = p[1];
		_tmp227_ = L;
		_tmp228_ = B;
		green = _tmp225_ + ((_tmp226_ * (_tmp227_ - l)) * (b - _tmp228_));
		_tmp229_ = blue;
		_tmp230_ = p[2];
		_tmp231_ = L;
		_tmp232_ = B;
		blue = _tmp229_ + ((_tmp230_ * (_tmp231_ - l)) * (b - _tmp232_));
	}
	scale = 1.0 / ((r - l) * (b - t));
	_tmp233_ = red;
	_tmp234_ = scale;
	output[offset] = (guchar) ((_tmp233_ * _tmp234_) + 0.5);
	_tmp235_ = green;
	_tmp236_ = scale;
	output[offset + 1] = (guchar) ((_tmp235_ * _tmp236_) + 0.5);
	_tmp237_ = blue;
	_tmp238_ = scale;
	output[offset + 2] = (guchar) ((_tmp237_ * _tmp238_) + 0.5);
}


static void
page_view_update_preview (PageView* self,
                          Page* page,
                          GdkPixbuf* * output_image,
                          gint output_width,
                          gint output_height,
                          ScanDirection scan_direction,
                          gint old_scan_line,
                          gint scan_line)
{
	gint input_width = 0;
	gint _tmp0_;
	gint _tmp1_;
	gint input_height = 0;
	gint _tmp2_;
	gint _tmp3_;
	gint L = 0;
	gint R = 0;
	gint T = 0;
	gint B = 0;
	gboolean _tmp4_ = FALSE;
	gboolean _tmp5_ = FALSE;
	gint _tmp26_;
	gint _tmp27_;
	gint _tmp28_;
	gint _tmp29_;
	gint _tmp30_;
	gint _tmp31_;
	guchar* output = NULL;
	guint8* _tmp32_;
	gint output_length1;
	gint _output_size_;
	gint output_rowstride = 0;
	gint _tmp33_;
	gint _tmp34_;
	gint output_n_channels = 0;
	gint _tmp35_;
	gint _tmp36_;
	gboolean _tmp37_;
	gboolean _tmp38_;
	g_return_if_fail (self != NULL);
	g_return_if_fail (page != NULL);
	_tmp0_ = page_get_width (page);
	_tmp1_ = _tmp0_;
	input_width = _tmp1_;
	_tmp2_ = page_get_height (page);
	_tmp3_ = _tmp2_;
	input_height = _tmp3_;
	if ((*output_image) == NULL) {
		_tmp5_ = TRUE;
	} else {
		gint _tmp6_;
		gint _tmp7_;
		_tmp6_ = gdk_pixbuf_get_width (*output_image);
		_tmp7_ = _tmp6_;
		_tmp5_ = _tmp7_ != output_width;
	}
	if (_tmp5_) {
		_tmp4_ = TRUE;
	} else {
		gint _tmp8_;
		gint _tmp9_;
		_tmp8_ = gdk_pixbuf_get_height (*output_image);
		_tmp9_ = _tmp8_;
		_tmp4_ = _tmp9_ != output_height;
	}
	if (_tmp4_) {
		GdkPixbuf* _tmp10_;
		_tmp10_ = gdk_pixbuf_new (GDK_COLORSPACE_RGB, FALSE, 8, output_width, output_height);
		_g_object_unref0 (*output_image);
		*output_image = _tmp10_;
		L = 0;
		R = output_width - 1;
		T = 0;
		B = output_height - 1;
	} else {
		switch (scan_direction) {
			case SCAN_DIRECTION_TOP_TO_BOTTOM:
			{
				gint _tmp11_;
				gint _tmp12_;
				L = 0;
				R = output_width - 1;
				_tmp11_ = input_height;
				T = (gint) ((((gdouble) old_scan_line) * output_height) / _tmp11_);
				_tmp12_ = input_height;
				B = (gint) (((((gdouble) scan_line) * output_height) / _tmp12_) + 0.5);
				break;
			}
			case SCAN_DIRECTION_LEFT_TO_RIGHT:
			{
				gint _tmp13_;
				gint _tmp14_;
				_tmp13_ = input_width;
				L = (gint) ((((gdouble) old_scan_line) * output_width) / _tmp13_);
				_tmp14_ = input_width;
				R = (gint) (((((gdouble) scan_line) * output_width) / _tmp14_) + 0.5);
				T = 0;
				B = output_height - 1;
				break;
			}
			case SCAN_DIRECTION_BOTTOM_TO_TOP:
			{
				gint _tmp15_;
				gint _tmp16_;
				gint _tmp17_;
				gint _tmp18_;
				L = 0;
				R = output_width - 1;
				_tmp15_ = input_height;
				_tmp16_ = input_height;
				T = (gint) ((((gdouble) (_tmp15_ - scan_line)) * output_height) / _tmp16_);
				_tmp17_ = input_height;
				_tmp18_ = input_height;
				B = (gint) (((((gdouble) (_tmp17_ - old_scan_line)) * output_height) / _tmp18_) + 0.5);
				break;
			}
			case SCAN_DIRECTION_RIGHT_TO_LEFT:
			{
				gint _tmp19_;
				gint _tmp20_;
				gint _tmp21_;
				gint _tmp22_;
				_tmp19_ = input_width;
				_tmp20_ = input_width;
				L = (gint) ((((gdouble) (_tmp19_ - scan_line)) * output_width) / _tmp20_);
				_tmp21_ = input_width;
				_tmp22_ = input_width;
				R = (gint) (((((gdouble) (_tmp21_ - old_scan_line)) * output_width) / _tmp22_) + 0.5);
				T = 0;
				B = output_height - 1;
				break;
			}
			default:
			{
				gint _tmp23_;
				gint _tmp24_;
				gint _tmp25_;
				T = 0;
				_tmp23_ = T;
				B = _tmp23_;
				_tmp24_ = B;
				R = _tmp24_;
				_tmp25_ = R;
				L = _tmp25_;
				break;
			}
		}
	}
	_tmp26_ = R;
	if (_tmp26_ >= output_width) {
		R = output_width - 1;
	}
	_tmp27_ = B;
	if (_tmp27_ >= output_height) {
		B = output_height - 1;
	}
	_tmp28_ = L;
	g_return_if_fail (_tmp28_ >= 0);
	_tmp29_ = R;
	g_return_if_fail (_tmp29_ < output_width);
	_tmp30_ = T;
	g_return_if_fail (_tmp30_ >= 0);
	_tmp31_ = B;
	g_return_if_fail (_tmp31_ < output_height);
	g_return_if_fail ((*output_image) != NULL);
	_tmp32_ = gdk_pixbuf_get_pixels (*output_image);
	output = _tmp32_;
	output_length1 = -1;
	_output_size_ = output_length1;
	_tmp33_ = gdk_pixbuf_get_rowstride (*output_image);
	_tmp34_ = _tmp33_;
	output_rowstride = _tmp34_;
	_tmp35_ = gdk_pixbuf_get_n_channels (*output_image);
	_tmp36_ = _tmp35_;
	output_n_channels = _tmp36_;
	_tmp37_ = page_get_has_data (page);
	_tmp38_ = _tmp37_;
	if (!_tmp38_) {
		{
			gint x = 0;
			gint _tmp39_;
			_tmp39_ = L;
			x = _tmp39_;
			{
				gboolean _tmp40_ = FALSE;
				_tmp40_ = TRUE;
				while (TRUE) {
					gint _tmp42_;
					gint _tmp43_;
					if (!_tmp40_) {
						gint _tmp41_;
						_tmp41_ = x;
						x = _tmp41_ + 1;
					}
					_tmp40_ = FALSE;
					_tmp42_ = x;
					_tmp43_ = R;
					if (!(_tmp42_ <= _tmp43_)) {
						break;
					}
					{
						gint y = 0;
						gint _tmp44_;
						_tmp44_ = T;
						y = _tmp44_;
						{
							gboolean _tmp45_ = FALSE;
							_tmp45_ = TRUE;
							while (TRUE) {
								gint _tmp47_;
								gint _tmp48_;
								gint o = 0;
								gint _tmp49_;
								gint _tmp50_;
								gint _tmp51_;
								gint _tmp52_;
								guchar* _tmp53_;
								gint _tmp53__length1;
								gint _tmp54_;
								guchar* _tmp55_;
								gint _tmp55__length1;
								gint _tmp56_;
								guchar* _tmp57_;
								gint _tmp57__length1;
								gint _tmp58_;
								if (!_tmp45_) {
									gint _tmp46_;
									_tmp46_ = y;
									y = _tmp46_ + 1;
								}
								_tmp45_ = FALSE;
								_tmp47_ = y;
								_tmp48_ = B;
								if (!(_tmp47_ <= _tmp48_)) {
									break;
								}
								_tmp49_ = output_rowstride;
								_tmp50_ = y;
								_tmp51_ = x;
								_tmp52_ = output_n_channels;
								o = (_tmp49_ * _tmp50_) + (_tmp51_ * _tmp52_);
								_tmp53_ = output;
								_tmp53__length1 = output_length1;
								_tmp54_ = o;
								_tmp55_ = output;
								_tmp55__length1 = output_length1;
								_tmp56_ = o;
								_tmp57_ = output;
								_tmp57__length1 = output_length1;
								_tmp58_ = o;
								_tmp57_[_tmp58_ + 2] = (guchar) 0xFF;
								_tmp55_[_tmp56_ + 1] = _tmp57_[_tmp58_ + 2];
								_tmp53_[_tmp54_] = _tmp55_[_tmp56_ + 1];
							}
						}
					}
				}
			}
		}
		return;
	}
	{
		gint x = 0;
		gint _tmp59_;
		_tmp59_ = L;
		x = _tmp59_;
		{
			gboolean _tmp60_ = FALSE;
			_tmp60_ = TRUE;
			while (TRUE) {
				gint _tmp62_;
				gint _tmp63_;
				gdouble l = 0.0;
				gint _tmp64_;
				gint _tmp65_;
				gdouble r = 0.0;
				gint _tmp66_;
				gint _tmp67_;
				if (!_tmp60_) {
					gint _tmp61_;
					_tmp61_ = x;
					x = _tmp61_ + 1;
				}
				_tmp60_ = FALSE;
				_tmp62_ = x;
				_tmp63_ = R;
				if (!(_tmp62_ <= _tmp63_)) {
					break;
				}
				_tmp64_ = x;
				_tmp65_ = input_width;
				l = (((gdouble) _tmp64_) * _tmp65_) / output_width;
				_tmp66_ = x;
				_tmp67_ = input_width;
				r = (((gdouble) (_tmp66_ + 1)) * _tmp67_) / output_width;
				{
					gint y = 0;
					gint _tmp68_;
					_tmp68_ = T;
					y = _tmp68_;
					{
						gboolean _tmp69_ = FALSE;
						_tmp69_ = TRUE;
						while (TRUE) {
							gint _tmp71_;
							gint _tmp72_;
							gdouble t = 0.0;
							gint _tmp73_;
							gint _tmp74_;
							gdouble b = 0.0;
							gint _tmp75_;
							gint _tmp76_;
							gdouble _tmp77_;
							gdouble _tmp78_;
							gdouble _tmp79_;
							gdouble _tmp80_;
							guchar* _tmp81_;
							gint _tmp81__length1;
							gint _tmp82_;
							gint _tmp83_;
							gint _tmp84_;
							gint _tmp85_;
							if (!_tmp69_) {
								gint _tmp70_;
								_tmp70_ = y;
								y = _tmp70_ + 1;
							}
							_tmp69_ = FALSE;
							_tmp71_ = y;
							_tmp72_ = B;
							if (!(_tmp71_ <= _tmp72_)) {
								break;
							}
							_tmp73_ = y;
							_tmp74_ = input_height;
							t = (((gdouble) _tmp73_) * _tmp74_) / output_height;
							_tmp75_ = y;
							_tmp76_ = input_height;
							b = (((gdouble) (_tmp75_ + 1)) * _tmp76_) / output_height;
							_tmp77_ = l;
							_tmp78_ = r;
							_tmp79_ = t;
							_tmp80_ = b;
							_tmp81_ = output;
							_tmp81__length1 = output_length1;
							_tmp82_ = output_rowstride;
							_tmp83_ = y;
							_tmp84_ = x;
							_tmp85_ = output_n_channels;
							page_view_set_pixel (self, page, _tmp77_, _tmp78_, _tmp79_, _tmp80_, _tmp81_, _tmp81__length1, (_tmp82_ * _tmp83_) + (_tmp84_ * _tmp85_));
						}
					}
				}
			}
		}
	}
}


static gint
page_view_get_preview_width (PageView* self)
{
	gint result = 0;
	gint _tmp0_;
	gint _tmp1_;
	gint _tmp2_;
	g_return_val_if_fail (self != NULL, 0);
	_tmp0_ = self->priv->width_;
	_tmp1_ = self->priv->border_width;
	_tmp2_ = self->priv->ruler_width;
	result = _tmp0_ - ((_tmp1_ + _tmp2_) * 2);
	return result;
}


static gint
page_view_get_preview_height (PageView* self)
{
	gint result = 0;
	gint _tmp0_;
	gint _tmp1_;
	gint _tmp2_;
	g_return_val_if_fail (self != NULL, 0);
	_tmp0_ = self->priv->height_;
	_tmp1_ = self->priv->border_width;
	_tmp2_ = self->priv->ruler_width;
	result = _tmp0_ - ((_tmp1_ + _tmp2_) * 2);
	return result;
}


static void
page_view_update_page_view (PageView* self)
{
	gboolean _tmp0_;
	gint old_scan_line = 0;
	gint _tmp1_;
	gint scan_line = 0;
	Page* _tmp2_;
	gint _tmp3_;
	gint _tmp4_;
	ScanDirection left_steps = 0;
	ScanDirection _tmp5_;
	Page* _tmp6_;
	ScanDirection _tmp7_;
	ScanDirection _tmp8_;
	gboolean _tmp9_ = FALSE;
	ScanDirection _tmp10_;
	Page* _tmp12_;
	ScanDirection _tmp13_;
	ScanDirection _tmp14_;
	Page* _tmp15_;
	Page* _tmp16_;
	ScanDirection _tmp17_;
	ScanDirection _tmp18_;
	gint _tmp19_;
	gint _tmp20_;
	gint _tmp21_;
	g_return_if_fail (self != NULL);
	_tmp0_ = self->priv->update_image;
	if (!_tmp0_) {
		return;
	}
	_tmp1_ = self->priv->scan_line;
	old_scan_line = _tmp1_;
	_tmp2_ = self->priv->_page;
	_tmp3_ = page_get_scan_line (_tmp2_);
	_tmp4_ = _tmp3_;
	scan_line = _tmp4_;
	_tmp5_ = self->priv->scan_direction;
	_tmp6_ = self->priv->_page;
	_tmp7_ = page_get_scan_direction (_tmp6_);
	_tmp8_ = _tmp7_;
	left_steps = _tmp5_ - _tmp8_;
	_tmp10_ = left_steps;
	if (_tmp10_ != 0) {
		GdkPixbuf* _tmp11_;
		_tmp11_ = self->priv->image;
		_tmp9_ = _tmp11_ != NULL;
	} else {
		_tmp9_ = FALSE;
	}
	if (_tmp9_) {
		_g_object_unref0 (self->priv->image);
		self->priv->image = NULL;
	}
	_tmp12_ = self->priv->_page;
	_tmp13_ = page_get_scan_direction (_tmp12_);
	_tmp14_ = _tmp13_;
	self->priv->scan_direction = _tmp14_;
	_tmp15_ = self->priv->_page;
	_tmp16_ = self->priv->_page;
	_tmp17_ = page_get_scan_direction (_tmp16_);
	_tmp18_ = _tmp17_;
	_tmp19_ = old_scan_line;
	_tmp20_ = scan_line;
	page_view_update_preview (self, _tmp15_, &self->priv->image, page_view_get_preview_width (self), page_view_get_preview_height (self), _tmp18_, _tmp19_, _tmp20_);
	self->priv->update_image = FALSE;
	_tmp21_ = scan_line;
	self->priv->scan_line = _tmp21_;
}


static gint
page_view_page_to_screen_x (PageView* self,
                            gint x)
{
	gint result = 0;
	Page* _tmp0_;
	gint _tmp1_;
	gint _tmp2_;
	g_return_val_if_fail (self != NULL, 0);
	_tmp0_ = self->priv->_page;
	_tmp1_ = page_get_width (_tmp0_);
	_tmp2_ = _tmp1_;
	result = (gint) (((((gdouble) x) * page_view_get_preview_width (self)) / _tmp2_) + 0.5);
	return result;
}


static gint
page_view_page_to_screen_y (PageView* self,
                            gint y)
{
	gint result = 0;
	Page* _tmp0_;
	gint _tmp1_;
	gint _tmp2_;
	g_return_val_if_fail (self != NULL, 0);
	_tmp0_ = self->priv->_page;
	_tmp1_ = page_get_height (_tmp0_);
	_tmp2_ = _tmp1_;
	result = (gint) (((((gdouble) y) * page_view_get_preview_height (self)) / _tmp2_) + 0.5);
	return result;
}


static gint
page_view_screen_to_page_x (PageView* self,
                            gint x)
{
	gint result = 0;
	Page* _tmp0_;
	gint _tmp1_;
	gint _tmp2_;
	g_return_val_if_fail (self != NULL, 0);
	_tmp0_ = self->priv->_page;
	_tmp1_ = page_get_width (_tmp0_);
	_tmp2_ = _tmp1_;
	result = (gint) (((((gdouble) x) * _tmp2_) / page_view_get_preview_width (self)) + 0.5);
	return result;
}


static gint
page_view_screen_to_page_y (PageView* self,
                            gint y)
{
	gint result = 0;
	Page* _tmp0_;
	gint _tmp1_;
	gint _tmp2_;
	g_return_val_if_fail (self != NULL, 0);
	_tmp0_ = self->priv->_page;
	_tmp1_ = page_get_height (_tmp0_);
	_tmp2_ = _tmp1_;
	result = (gint) (((((gdouble) y) * _tmp2_) / page_view_get_preview_height (self)) + 0.5);
	return result;
}


static CropLocation
page_view_get_crop_location (PageView* self,
                             gint x,
                             gint y)
{
	CropLocation result = 0;
	Page* _tmp0_;
	gboolean _tmp1_;
	gboolean _tmp2_;
	gint cx = 0;
	Page* _tmp3_;
	gint _tmp4_;
	gint _tmp5_;
	gint cy = 0;
	Page* _tmp6_;
	gint _tmp7_;
	gint _tmp8_;
	gint cw = 0;
	Page* _tmp9_;
	gint _tmp10_;
	gint _tmp11_;
	gint ch = 0;
	Page* _tmp12_;
	gint _tmp13_;
	gint _tmp14_;
	gint dx = 0;
	gint _tmp15_;
	gint _tmp16_;
	gint _tmp17_;
	gint dy = 0;
	gint _tmp18_;
	gint _tmp19_;
	gint _tmp20_;
	gint dw = 0;
	gint _tmp21_;
	gint _tmp22_;
	gint _tmp23_;
	gint dh = 0;
	gint _tmp24_;
	gint _tmp25_;
	gint _tmp26_;
	gint ix = 0;
	gint _tmp27_;
	gint iy = 0;
	gint _tmp28_;
	gboolean _tmp29_ = FALSE;
	gboolean _tmp30_ = FALSE;
	gboolean _tmp31_ = FALSE;
	gint _tmp32_;
	gchar* name = NULL;
	Page* _tmp38_;
	const gchar* _tmp39_;
	const gchar* _tmp40_;
	gchar* _tmp41_;
	const gchar* _tmp42_;
	gint crop_border = 0;
	gint _tmp43_;
	gint _tmp44_;
	gint _tmp46_;
	gint _tmp47_;
	gboolean _tmp49_ = FALSE;
	gint _tmp50_;
	gint _tmp51_;
	gboolean _tmp54_ = FALSE;
	gint _tmp55_;
	gint _tmp56_;
	gint _tmp57_;
	gboolean _tmp60_ = FALSE;
	gint _tmp61_;
	gint _tmp62_;
	gboolean _tmp66_ = FALSE;
	gint _tmp67_;
	gint _tmp68_;
	gint _tmp69_;
	gint _tmp73_;
	gint _tmp74_;
	gint _tmp75_;
	gint _tmp76_;
	gint _tmp77_;
	gint _tmp78_;
	gint _tmp79_;
	gint _tmp80_;
	gint _tmp81_;
	gint _tmp82_;
	g_return_val_if_fail (self != NULL, 0);
	_tmp0_ = self->priv->_page;
	_tmp1_ = page_get_has_crop (_tmp0_);
	_tmp2_ = _tmp1_;
	if (!_tmp2_) {
		result = CROP_LOCATION_NONE;
		return result;
	}
	_tmp3_ = self->priv->_page;
	_tmp4_ = page_get_crop_x (_tmp3_);
	_tmp5_ = _tmp4_;
	cx = _tmp5_;
	_tmp6_ = self->priv->_page;
	_tmp7_ = page_get_crop_y (_tmp6_);
	_tmp8_ = _tmp7_;
	cy = _tmp8_;
	_tmp9_ = self->priv->_page;
	_tmp10_ = page_get_crop_width (_tmp9_);
	_tmp11_ = _tmp10_;
	cw = _tmp11_;
	_tmp12_ = self->priv->_page;
	_tmp13_ = page_get_crop_height (_tmp12_);
	_tmp14_ = _tmp13_;
	ch = _tmp14_;
	_tmp15_ = cx;
	_tmp16_ = self->priv->border_width;
	_tmp17_ = self->priv->ruler_width;
	dx = (page_view_page_to_screen_x (self, _tmp15_) + _tmp16_) + _tmp17_;
	_tmp18_ = cy;
	_tmp19_ = self->priv->border_width;
	_tmp20_ = self->priv->ruler_width;
	dy = (page_view_page_to_screen_y (self, _tmp18_) + _tmp19_) + _tmp20_;
	_tmp21_ = cw;
	_tmp22_ = self->priv->border_width;
	_tmp23_ = self->priv->ruler_width;
	dw = (page_view_page_to_screen_x (self, _tmp21_) + _tmp22_) + _tmp23_;
	_tmp24_ = ch;
	_tmp25_ = self->priv->border_width;
	_tmp26_ = self->priv->ruler_width;
	dh = (page_view_page_to_screen_y (self, _tmp24_) + _tmp25_) + _tmp26_;
	_tmp27_ = dx;
	ix = x - _tmp27_;
	_tmp28_ = dy;
	iy = y - _tmp28_;
	_tmp32_ = ix;
	if (_tmp32_ < 0) {
		_tmp31_ = TRUE;
	} else {
		gint _tmp33_;
		gint _tmp34_;
		_tmp33_ = ix;
		_tmp34_ = dw;
		_tmp31_ = _tmp33_ > _tmp34_;
	}
	if (_tmp31_) {
		_tmp30_ = TRUE;
	} else {
		gint _tmp35_;
		_tmp35_ = iy;
		_tmp30_ = _tmp35_ < 0;
	}
	if (_tmp30_) {
		_tmp29_ = TRUE;
	} else {
		gint _tmp36_;
		gint _tmp37_;
		_tmp36_ = iy;
		_tmp37_ = dh;
		_tmp29_ = _tmp36_ > _tmp37_;
	}
	if (_tmp29_) {
		result = CROP_LOCATION_NONE;
		return result;
	}
	_tmp38_ = self->priv->_page;
	_tmp39_ = page_get_crop_name (_tmp38_);
	_tmp40_ = _tmp39_;
	_tmp41_ = g_strdup (_tmp40_);
	name = _tmp41_;
	_tmp42_ = name;
	if (_tmp42_ != NULL) {
		result = CROP_LOCATION_MIDDLE;
		_g_free0 (name);
		return result;
	}
	crop_border = 20;
	_tmp43_ = dw;
	_tmp44_ = crop_border;
	if (_tmp43_ < (_tmp44_ * 3)) {
		gint _tmp45_;
		_tmp45_ = dw;
		crop_border = _tmp45_ / 3;
	}
	_tmp46_ = dh;
	_tmp47_ = crop_border;
	if (_tmp46_ < (_tmp47_ * 3)) {
		gint _tmp48_;
		_tmp48_ = dh;
		crop_border = _tmp48_ / 3;
	}
	_tmp50_ = ix;
	_tmp51_ = crop_border;
	if (_tmp50_ < _tmp51_) {
		gint _tmp52_;
		gint _tmp53_;
		_tmp52_ = iy;
		_tmp53_ = crop_border;
		_tmp49_ = _tmp52_ < _tmp53_;
	} else {
		_tmp49_ = FALSE;
	}
	if (_tmp49_) {
		result = CROP_LOCATION_TOP_LEFT;
		_g_free0 (name);
		return result;
	}
	_tmp55_ = ix;
	_tmp56_ = dw;
	_tmp57_ = crop_border;
	if (_tmp55_ > (_tmp56_ - _tmp57_)) {
		gint _tmp58_;
		gint _tmp59_;
		_tmp58_ = iy;
		_tmp59_ = crop_border;
		_tmp54_ = _tmp58_ < _tmp59_;
	} else {
		_tmp54_ = FALSE;
	}
	if (_tmp54_) {
		result = CROP_LOCATION_TOP_RIGHT;
		_g_free0 (name);
		return result;
	}
	_tmp61_ = ix;
	_tmp62_ = crop_border;
	if (_tmp61_ < _tmp62_) {
		gint _tmp63_;
		gint _tmp64_;
		gint _tmp65_;
		_tmp63_ = iy;
		_tmp64_ = dh;
		_tmp65_ = crop_border;
		_tmp60_ = _tmp63_ > (_tmp64_ - _tmp65_);
	} else {
		_tmp60_ = FALSE;
	}
	if (_tmp60_) {
		result = CROP_LOCATION_BOTTOM_LEFT;
		_g_free0 (name);
		return result;
	}
	_tmp67_ = ix;
	_tmp68_ = dw;
	_tmp69_ = crop_border;
	if (_tmp67_ > (_tmp68_ - _tmp69_)) {
		gint _tmp70_;
		gint _tmp71_;
		gint _tmp72_;
		_tmp70_ = iy;
		_tmp71_ = dh;
		_tmp72_ = crop_border;
		_tmp66_ = _tmp70_ > (_tmp71_ - _tmp72_);
	} else {
		_tmp66_ = FALSE;
	}
	if (_tmp66_) {
		result = CROP_LOCATION_BOTTOM_RIGHT;
		_g_free0 (name);
		return result;
	}
	_tmp73_ = ix;
	_tmp74_ = crop_border;
	if (_tmp73_ < _tmp74_) {
		result = CROP_LOCATION_LEFT;
		_g_free0 (name);
		return result;
	}
	_tmp75_ = ix;
	_tmp76_ = dw;
	_tmp77_ = crop_border;
	if (_tmp75_ > (_tmp76_ - _tmp77_)) {
		result = CROP_LOCATION_RIGHT;
		_g_free0 (name);
		return result;
	}
	_tmp78_ = iy;
	_tmp79_ = crop_border;
	if (_tmp78_ < _tmp79_) {
		result = CROP_LOCATION_TOP;
		_g_free0 (name);
		return result;
	}
	_tmp80_ = iy;
	_tmp81_ = dh;
	_tmp82_ = crop_border;
	if (_tmp80_ > (_tmp81_ - _tmp82_)) {
		result = CROP_LOCATION_BOTTOM;
		_g_free0 (name);
		return result;
	}
	result = CROP_LOCATION_MIDDLE;
	_g_free0 (name);
	return result;
}


void
page_view_button_press (PageView* self,
                        gint x,
                        gint y)
{
	CropLocation location = 0;
	CropLocation _tmp0_;
	g_return_if_fail (self != NULL);
	location = page_view_get_crop_location (self, x, y);
	_tmp0_ = location;
	if (_tmp0_ != CROP_LOCATION_NONE) {
		CropLocation _tmp1_;
		Page* _tmp2_;
		gint _tmp3_;
		gint _tmp4_;
		Page* _tmp5_;
		gint _tmp6_;
		gint _tmp7_;
		Page* _tmp8_;
		gint _tmp9_;
		gint _tmp10_;
		Page* _tmp11_;
		gint _tmp12_;
		gint _tmp13_;
		_tmp1_ = location;
		self->priv->crop_location = _tmp1_;
		self->priv->selected_crop_px = (gdouble) x;
		self->priv->selected_crop_py = (gdouble) y;
		_tmp2_ = self->priv->_page;
		_tmp3_ = page_get_crop_x (_tmp2_);
		_tmp4_ = _tmp3_;
		self->priv->selected_crop_x = _tmp4_;
		_tmp5_ = self->priv->_page;
		_tmp6_ = page_get_crop_y (_tmp5_);
		_tmp7_ = _tmp6_;
		self->priv->selected_crop_y = _tmp7_;
		_tmp8_ = self->priv->_page;
		_tmp9_ = page_get_crop_width (_tmp8_);
		_tmp10_ = _tmp9_;
		self->priv->selected_crop_w = _tmp10_;
		_tmp11_ = self->priv->_page;
		_tmp12_ = page_get_crop_height (_tmp11_);
		_tmp13_ = _tmp12_;
		self->priv->selected_crop_h = _tmp13_;
	}
}


void
page_view_motion (PageView* self,
                  gint x,
                  gint y)
{
	CropLocation location = 0;
	GdkCursorType cursor = 0;
	CropLocation _tmp0_;
	CropLocation _tmp1_;
	gint pw = 0;
	Page* _tmp3_;
	gint _tmp4_;
	gint _tmp5_;
	gint ph = 0;
	Page* _tmp6_;
	gint _tmp7_;
	gint _tmp8_;
	gint cw = 0;
	Page* _tmp9_;
	gint _tmp10_;
	gint _tmp11_;
	gint ch = 0;
	Page* _tmp12_;
	gint _tmp13_;
	gint _tmp14_;
	gint dx = 0;
	gdouble _tmp15_;
	gint dy = 0;
	gdouble _tmp16_;
	gint new_x = 0;
	gint _tmp17_;
	gint new_y = 0;
	gint _tmp18_;
	gint new_w = 0;
	gint _tmp19_;
	gint new_h = 0;
	gint _tmp20_;
	gint min_size = 0;
	gboolean _tmp21_ = FALSE;
	gboolean _tmp22_ = FALSE;
	CropLocation _tmp23_;
	gboolean _tmp34_ = FALSE;
	gboolean _tmp35_ = FALSE;
	CropLocation _tmp36_;
	gboolean _tmp47_ = FALSE;
	gboolean _tmp48_ = FALSE;
	CropLocation _tmp49_;
	gboolean _tmp64_ = FALSE;
	gboolean _tmp65_ = FALSE;
	CropLocation _tmp66_;
	CropLocation _tmp81_;
	CropLocation _tmp102_;
	gboolean _tmp107_ = FALSE;
	gboolean _tmp108_ = FALSE;
	CropLocation _tmp109_;
	gboolean _tmp116_ = FALSE;
	gboolean _tmp117_ = FALSE;
	CropLocation _tmp118_;
	gboolean _tmp125_ = FALSE;
	gboolean _tmp126_ = FALSE;
	CropLocation _tmp127_;
	gboolean _tmp132_ = FALSE;
	gboolean _tmp133_ = FALSE;
	CropLocation _tmp134_;
	Page* _tmp139_;
	gint _tmp140_;
	gint _tmp141_;
	gboolean _tmp142_ = FALSE;
	gint _tmp143_;
	gint _tmp144_;
	g_return_if_fail (self != NULL);
	location = page_view_get_crop_location (self, x, y);
	_tmp0_ = location;
	switch (_tmp0_) {
		case CROP_LOCATION_MIDDLE:
		{
			cursor = GDK_HAND1;
			break;
		}
		case CROP_LOCATION_TOP:
		{
			cursor = GDK_TOP_SIDE;
			break;
		}
		case CROP_LOCATION_BOTTOM:
		{
			cursor = GDK_BOTTOM_SIDE;
			break;
		}
		case CROP_LOCATION_LEFT:
		{
			cursor = GDK_LEFT_SIDE;
			break;
		}
		case CROP_LOCATION_RIGHT:
		{
			cursor = GDK_RIGHT_SIDE;
			break;
		}
		case CROP_LOCATION_TOP_LEFT:
		{
			cursor = GDK_TOP_LEFT_CORNER;
			break;
		}
		case CROP_LOCATION_TOP_RIGHT:
		{
			cursor = GDK_TOP_RIGHT_CORNER;
			break;
		}
		case CROP_LOCATION_BOTTOM_LEFT:
		{
			cursor = GDK_BOTTOM_LEFT_CORNER;
			break;
		}
		case CROP_LOCATION_BOTTOM_RIGHT:
		{
			cursor = GDK_BOTTOM_RIGHT_CORNER;
			break;
		}
		default:
		{
			cursor = GDK_ARROW;
			break;
		}
	}
	_tmp1_ = self->priv->crop_location;
	if (_tmp1_ == CROP_LOCATION_NONE) {
		GdkCursorType _tmp2_;
		_tmp2_ = cursor;
		page_view_set_cursor (self, _tmp2_);
		return;
	}
	_tmp3_ = self->priv->_page;
	_tmp4_ = page_get_width (_tmp3_);
	_tmp5_ = _tmp4_;
	pw = _tmp5_;
	_tmp6_ = self->priv->_page;
	_tmp7_ = page_get_height (_tmp6_);
	_tmp8_ = _tmp7_;
	ph = _tmp8_;
	_tmp9_ = self->priv->_page;
	_tmp10_ = page_get_crop_width (_tmp9_);
	_tmp11_ = _tmp10_;
	cw = _tmp11_;
	_tmp12_ = self->priv->_page;
	_tmp13_ = page_get_crop_height (_tmp12_);
	_tmp14_ = _tmp13_;
	ch = _tmp14_;
	_tmp15_ = self->priv->selected_crop_px;
	dx = page_view_screen_to_page_x (self, x - ((gint) _tmp15_));
	_tmp16_ = self->priv->selected_crop_py;
	dy = page_view_screen_to_page_y (self, y - ((gint) _tmp16_));
	_tmp17_ = self->priv->selected_crop_x;
	new_x = _tmp17_;
	_tmp18_ = self->priv->selected_crop_y;
	new_y = _tmp18_;
	_tmp19_ = self->priv->selected_crop_w;
	new_w = _tmp19_;
	_tmp20_ = self->priv->selected_crop_h;
	new_h = _tmp20_;
	min_size = page_view_screen_to_page_x (self, 15);
	_tmp23_ = self->priv->crop_location;
	if (_tmp23_ == CROP_LOCATION_TOP_LEFT) {
		_tmp22_ = TRUE;
	} else {
		CropLocation _tmp24_;
		_tmp24_ = self->priv->crop_location;
		_tmp22_ = _tmp24_ == CROP_LOCATION_LEFT;
	}
	if (_tmp22_) {
		_tmp21_ = TRUE;
	} else {
		CropLocation _tmp25_;
		_tmp25_ = self->priv->crop_location;
		_tmp21_ = _tmp25_ == CROP_LOCATION_BOTTOM_LEFT;
	}
	if (_tmp21_) {
		gint _tmp26_;
		gint _tmp27_;
		gint _tmp28_;
		gint _tmp31_;
		gint _tmp32_;
		_tmp26_ = dx;
		_tmp27_ = new_w;
		_tmp28_ = min_size;
		if (_tmp26_ > (_tmp27_ - _tmp28_)) {
			gint _tmp29_;
			gint _tmp30_;
			_tmp29_ = new_w;
			_tmp30_ = min_size;
			dx = _tmp29_ - _tmp30_;
		}
		_tmp31_ = new_x;
		_tmp32_ = dx;
		if ((_tmp31_ + _tmp32_) < 0) {
			gint _tmp33_;
			_tmp33_ = new_x;
			dx = -_tmp33_;
		}
	}
	_tmp36_ = self->priv->crop_location;
	if (_tmp36_ == CROP_LOCATION_TOP_LEFT) {
		_tmp35_ = TRUE;
	} else {
		CropLocation _tmp37_;
		_tmp37_ = self->priv->crop_location;
		_tmp35_ = _tmp37_ == CROP_LOCATION_TOP;
	}
	if (_tmp35_) {
		_tmp34_ = TRUE;
	} else {
		CropLocation _tmp38_;
		_tmp38_ = self->priv->crop_location;
		_tmp34_ = _tmp38_ == CROP_LOCATION_TOP_RIGHT;
	}
	if (_tmp34_) {
		gint _tmp39_;
		gint _tmp40_;
		gint _tmp41_;
		gint _tmp44_;
		gint _tmp45_;
		_tmp39_ = dy;
		_tmp40_ = new_h;
		_tmp41_ = min_size;
		if (_tmp39_ > (_tmp40_ - _tmp41_)) {
			gint _tmp42_;
			gint _tmp43_;
			_tmp42_ = new_h;
			_tmp43_ = min_size;
			dy = _tmp42_ - _tmp43_;
		}
		_tmp44_ = new_y;
		_tmp45_ = dy;
		if ((_tmp44_ + _tmp45_) < 0) {
			gint _tmp46_;
			_tmp46_ = new_y;
			dy = -_tmp46_;
		}
	}
	_tmp49_ = self->priv->crop_location;
	if (_tmp49_ == CROP_LOCATION_TOP_RIGHT) {
		_tmp48_ = TRUE;
	} else {
		CropLocation _tmp50_;
		_tmp50_ = self->priv->crop_location;
		_tmp48_ = _tmp50_ == CROP_LOCATION_RIGHT;
	}
	if (_tmp48_) {
		_tmp47_ = TRUE;
	} else {
		CropLocation _tmp51_;
		_tmp51_ = self->priv->crop_location;
		_tmp47_ = _tmp51_ == CROP_LOCATION_BOTTOM_RIGHT;
	}
	if (_tmp47_) {
		gint _tmp52_;
		gint _tmp53_;
		gint _tmp54_;
		gint _tmp57_;
		gint _tmp58_;
		gint _tmp59_;
		gint _tmp60_;
		_tmp52_ = dx;
		_tmp53_ = min_size;
		_tmp54_ = new_w;
		if (_tmp52_ < (_tmp53_ - _tmp54_)) {
			gint _tmp55_;
			gint _tmp56_;
			_tmp55_ = min_size;
			_tmp56_ = new_w;
			dx = _tmp55_ - _tmp56_;
		}
		_tmp57_ = new_x;
		_tmp58_ = new_w;
		_tmp59_ = dx;
		_tmp60_ = pw;
		if (((_tmp57_ + _tmp58_) + _tmp59_) > _tmp60_) {
			gint _tmp61_;
			gint _tmp62_;
			gint _tmp63_;
			_tmp61_ = pw;
			_tmp62_ = new_x;
			_tmp63_ = new_w;
			dx = (_tmp61_ - _tmp62_) - _tmp63_;
		}
	}
	_tmp66_ = self->priv->crop_location;
	if (_tmp66_ == CROP_LOCATION_BOTTOM_LEFT) {
		_tmp65_ = TRUE;
	} else {
		CropLocation _tmp67_;
		_tmp67_ = self->priv->crop_location;
		_tmp65_ = _tmp67_ == CROP_LOCATION_BOTTOM;
	}
	if (_tmp65_) {
		_tmp64_ = TRUE;
	} else {
		CropLocation _tmp68_;
		_tmp68_ = self->priv->crop_location;
		_tmp64_ = _tmp68_ == CROP_LOCATION_BOTTOM_RIGHT;
	}
	if (_tmp64_) {
		gint _tmp69_;
		gint _tmp70_;
		gint _tmp71_;
		gint _tmp74_;
		gint _tmp75_;
		gint _tmp76_;
		gint _tmp77_;
		_tmp69_ = dy;
		_tmp70_ = min_size;
		_tmp71_ = new_h;
		if (_tmp69_ < (_tmp70_ - _tmp71_)) {
			gint _tmp72_;
			gint _tmp73_;
			_tmp72_ = min_size;
			_tmp73_ = new_h;
			dy = _tmp72_ - _tmp73_;
		}
		_tmp74_ = new_y;
		_tmp75_ = new_h;
		_tmp76_ = dy;
		_tmp77_ = ph;
		if (((_tmp74_ + _tmp75_) + _tmp76_) > _tmp77_) {
			gint _tmp78_;
			gint _tmp79_;
			gint _tmp80_;
			_tmp78_ = ph;
			_tmp79_ = new_y;
			_tmp80_ = new_h;
			dy = (_tmp78_ - _tmp79_) - _tmp80_;
		}
	}
	_tmp81_ = self->priv->crop_location;
	if (_tmp81_ == CROP_LOCATION_MIDDLE) {
		gint _tmp82_;
		gint _tmp83_;
		gint _tmp84_;
		gint _tmp85_;
		gint _tmp89_;
		gint _tmp90_;
		gint _tmp92_;
		gint _tmp93_;
		gint _tmp94_;
		gint _tmp95_;
		gint _tmp99_;
		gint _tmp100_;
		_tmp82_ = new_x;
		_tmp83_ = dx;
		_tmp84_ = new_w;
		_tmp85_ = pw;
		if (((_tmp82_ + _tmp83_) + _tmp84_) > _tmp85_) {
			gint _tmp86_;
			gint _tmp87_;
			gint _tmp88_;
			_tmp86_ = pw;
			_tmp87_ = new_x;
			_tmp88_ = new_w;
			dx = (_tmp86_ - _tmp87_) - _tmp88_;
		}
		_tmp89_ = new_x;
		_tmp90_ = dx;
		if ((_tmp89_ + _tmp90_) < 0) {
			gint _tmp91_;
			_tmp91_ = new_x;
			dx = -_tmp91_;
		}
		_tmp92_ = new_y;
		_tmp93_ = dy;
		_tmp94_ = new_h;
		_tmp95_ = ph;
		if (((_tmp92_ + _tmp93_) + _tmp94_) > _tmp95_) {
			gint _tmp96_;
			gint _tmp97_;
			gint _tmp98_;
			_tmp96_ = ph;
			_tmp97_ = new_y;
			_tmp98_ = new_h;
			dy = (_tmp96_ - _tmp97_) - _tmp98_;
		}
		_tmp99_ = new_y;
		_tmp100_ = dy;
		if ((_tmp99_ + _tmp100_) < 0) {
			gint _tmp101_;
			_tmp101_ = new_y;
			dy = -_tmp101_;
		}
	}
	_tmp102_ = self->priv->crop_location;
	if (_tmp102_ == CROP_LOCATION_MIDDLE) {
		gint _tmp103_;
		gint _tmp104_;
		gint _tmp105_;
		gint _tmp106_;
		_tmp103_ = new_x;
		_tmp104_ = dx;
		new_x = _tmp103_ + _tmp104_;
		_tmp105_ = new_y;
		_tmp106_ = dy;
		new_y = _tmp105_ + _tmp106_;
	}
	_tmp109_ = self->priv->crop_location;
	if (_tmp109_ == CROP_LOCATION_TOP_LEFT) {
		_tmp108_ = TRUE;
	} else {
		CropLocation _tmp110_;
		_tmp110_ = self->priv->crop_location;
		_tmp108_ = _tmp110_ == CROP_LOCATION_LEFT;
	}
	if (_tmp108_) {
		_tmp107_ = TRUE;
	} else {
		CropLocation _tmp111_;
		_tmp111_ = self->priv->crop_location;
		_tmp107_ = _tmp111_ == CROP_LOCATION_BOTTOM_LEFT;
	}
	if (_tmp107_) {
		gint _tmp112_;
		gint _tmp113_;
		gint _tmp114_;
		gint _tmp115_;
		_tmp112_ = new_x;
		_tmp113_ = dx;
		new_x = _tmp112_ + _tmp113_;
		_tmp114_ = new_w;
		_tmp115_ = dx;
		new_w = _tmp114_ - _tmp115_;
	}
	_tmp118_ = self->priv->crop_location;
	if (_tmp118_ == CROP_LOCATION_TOP_LEFT) {
		_tmp117_ = TRUE;
	} else {
		CropLocation _tmp119_;
		_tmp119_ = self->priv->crop_location;
		_tmp117_ = _tmp119_ == CROP_LOCATION_TOP;
	}
	if (_tmp117_) {
		_tmp116_ = TRUE;
	} else {
		CropLocation _tmp120_;
		_tmp120_ = self->priv->crop_location;
		_tmp116_ = _tmp120_ == CROP_LOCATION_TOP_RIGHT;
	}
	if (_tmp116_) {
		gint _tmp121_;
		gint _tmp122_;
		gint _tmp123_;
		gint _tmp124_;
		_tmp121_ = new_y;
		_tmp122_ = dy;
		new_y = _tmp121_ + _tmp122_;
		_tmp123_ = new_h;
		_tmp124_ = dy;
		new_h = _tmp123_ - _tmp124_;
	}
	_tmp127_ = self->priv->crop_location;
	if (_tmp127_ == CROP_LOCATION_TOP_RIGHT) {
		_tmp126_ = TRUE;
	} else {
		CropLocation _tmp128_;
		_tmp128_ = self->priv->crop_location;
		_tmp126_ = _tmp128_ == CROP_LOCATION_RIGHT;
	}
	if (_tmp126_) {
		_tmp125_ = TRUE;
	} else {
		CropLocation _tmp129_;
		_tmp129_ = self->priv->crop_location;
		_tmp125_ = _tmp129_ == CROP_LOCATION_BOTTOM_RIGHT;
	}
	if (_tmp125_) {
		gint _tmp130_;
		gint _tmp131_;
		_tmp130_ = new_w;
		_tmp131_ = dx;
		new_w = _tmp130_ + _tmp131_;
	}
	_tmp134_ = self->priv->crop_location;
	if (_tmp134_ == CROP_LOCATION_BOTTOM_LEFT) {
		_tmp133_ = TRUE;
	} else {
		CropLocation _tmp135_;
		_tmp135_ = self->priv->crop_location;
		_tmp133_ = _tmp135_ == CROP_LOCATION_BOTTOM;
	}
	if (_tmp133_) {
		_tmp132_ = TRUE;
	} else {
		CropLocation _tmp136_;
		_tmp136_ = self->priv->crop_location;
		_tmp132_ = _tmp136_ == CROP_LOCATION_BOTTOM_RIGHT;
	}
	if (_tmp132_) {
		gint _tmp137_;
		gint _tmp138_;
		_tmp137_ = new_h;
		_tmp138_ = dy;
		new_h = _tmp137_ + _tmp138_;
	}
	_tmp139_ = self->priv->_page;
	_tmp140_ = new_x;
	_tmp141_ = new_y;
	page_move_crop (_tmp139_, _tmp140_, _tmp141_);
	_tmp143_ = new_w;
	_tmp144_ = cw;
	if (_tmp143_ != _tmp144_) {
		_tmp142_ = TRUE;
	} else {
		gint _tmp145_;
		gint _tmp146_;
		_tmp145_ = new_h;
		_tmp146_ = ch;
		_tmp142_ = _tmp145_ != _tmp146_;
	}
	if (_tmp142_) {
		Page* _tmp147_;
		gint _tmp148_;
		gint _tmp149_;
		_tmp147_ = self->priv->_page;
		_tmp148_ = new_w;
		_tmp149_ = new_h;
		page_set_custom_crop (_tmp147_, _tmp148_, _tmp149_);
	}
}


void
page_view_button_release (PageView* self,
                          gint x,
                          gint y)
{
	g_return_if_fail (self != NULL);
	self->priv->crop_location = CROP_LOCATION_NONE;
	g_signal_emit (self, page_view_signals[PAGE_VIEW_CHANGED_SIGNAL], 0);
}


static gboolean
page_view_animation_cb (PageView* self)
{
	gboolean result = FALSE;
	gint _tmp0_;
	gint _tmp1_;
	g_return_val_if_fail (self != NULL, FALSE);
	_tmp0_ = self->priv->animate_segment;
	_tmp1_ = self->priv->animate_n_segments;
	self->priv->animate_segment = (_tmp0_ + 1) % _tmp1_;
	g_signal_emit (self, page_view_signals[PAGE_VIEW_CHANGED_SIGNAL], 0);
	result = TRUE;
	return result;
}


static gboolean
_page_view_animation_cb_gsource_func (gpointer self)
{
	gboolean result;
	result = page_view_animation_cb ((PageView*) self);
	return result;
}


static void
page_view_update_animation (PageView* self)
{
	gboolean animate = FALSE;
	gboolean is_animating = FALSE;
	gboolean _tmp0_ = FALSE;
	Page* _tmp1_;
	gboolean _tmp2_;
	gboolean _tmp3_;
	guint _tmp7_;
	gboolean _tmp8_;
	gboolean _tmp9_;
	gboolean _tmp10_;
	g_return_if_fail (self != NULL);
	_tmp1_ = self->priv->_page;
	_tmp2_ = page_get_is_scanning (_tmp1_);
	_tmp3_ = _tmp2_;
	if (_tmp3_) {
		Page* _tmp4_;
		gboolean _tmp5_;
		gboolean _tmp6_;
		_tmp4_ = self->priv->_page;
		_tmp5_ = page_get_has_data (_tmp4_);
		_tmp6_ = _tmp5_;
		_tmp0_ = !_tmp6_;
	} else {
		_tmp0_ = FALSE;
	}
	animate = _tmp0_;
	_tmp7_ = self->priv->animate_timeout;
	is_animating = _tmp7_ != ((guint) 0);
	_tmp8_ = animate;
	_tmp9_ = is_animating;
	if (_tmp8_ == _tmp9_) {
		return;
	}
	_tmp10_ = animate;
	if (_tmp10_) {
		guint _tmp11_;
		self->priv->animate_segment = 0;
		_tmp11_ = self->priv->animate_timeout;
		if (_tmp11_ == ((guint) 0)) {
			self->priv->animate_timeout = g_timeout_add_full (G_PRIORITY_DEFAULT, (guint) 150, _page_view_animation_cb_gsource_func, g_object_ref (self), g_object_unref);
		}
	} else {
		guint _tmp12_;
		_tmp12_ = self->priv->animate_timeout;
		if (_tmp12_ != ((guint) 0)) {
			guint _tmp13_;
			_tmp13_ = self->priv->animate_timeout;
			g_source_remove (_tmp13_);
		}
		self->priv->animate_timeout = (guint) 0;
	}
}


void
page_view_render (PageView* self,
                  cairo_t* context)
{
	gint w = 0;
	gint h = 0;
	gint _tmp0_;
	gint _tmp1_;
	gint _tmp2_;
	gint _tmp3_;
	gint _tmp4_;
	gint _tmp5_;
	GdkPixbuf* _tmp6_;
	gint _tmp7_;
	gint _tmp8_;
	gint _tmp9_;
	gint ruler_tick = 0;
	gdouble line = 0.0;
	gint big_ruler_tick = 0;
	gboolean _tmp60_ = FALSE;
	Page* _tmp61_;
	gboolean _tmp62_;
	gboolean _tmp63_;
	Page* _tmp100_;
	gboolean _tmp101_;
	gboolean _tmp102_;
	g_return_if_fail (self != NULL);
	g_return_if_fail (context != NULL);
	page_view_update_animation (self);
	page_view_update_page_view (self);
	w = page_view_get_preview_width (self);
	h = page_view_get_preview_height (self);
	cairo_set_line_width (context, (gdouble) 1);
	_tmp0_ = self->priv->_x_offset;
	_tmp1_ = self->priv->_y_offset;
	cairo_translate (context, (gdouble) _tmp0_, (gdouble) _tmp1_);
	_tmp2_ = self->priv->border_width;
	_tmp3_ = self->priv->ruler_width;
	_tmp4_ = self->priv->border_width;
	_tmp5_ = self->priv->ruler_width;
	cairo_translate (context, (gdouble) (_tmp2_ + _tmp3_), (gdouble) (_tmp4_ + _tmp5_));
	_tmp6_ = self->priv->image;
	gdk_cairo_set_source_pixbuf (context, _tmp6_, (gdouble) 0, (gdouble) 0);
	cairo_paint (context);
	cairo_set_source_rgb (context, (gdouble) 0, (gdouble) 0, (gdouble) 0);
	_tmp7_ = self->priv->border_width;
	cairo_set_line_width (context, (gdouble) _tmp7_);
	_tmp8_ = w;
	_tmp9_ = h;
	cairo_rectangle (context, (gdouble) 0, 0.0, (gdouble) _tmp8_, (gdouble) _tmp9_);
	cairo_stroke (context);
	cairo_set_line_width (context, (gdouble) 1);
	ruler_tick = 0;
	line = 0.0;
	big_ruler_tick = 5;
	while (TRUE) {
		gint _tmp10_;
		Page* _tmp11_;
		gint _tmp12_;
		gint _tmp13_;
		gint _tmp14_;
		gint _tmp15_;
		gint _tmp30_;
		Page* _tmp31_;
		gint _tmp32_;
		gint _tmp33_;
		gint _tmp34_;
		_tmp10_ = ruler_tick;
		_tmp11_ = self->priv->_page;
		_tmp12_ = page_get_width (_tmp11_);
		_tmp13_ = _tmp12_;
		if (!(_tmp10_ <= _tmp13_)) {
			break;
		}
		_tmp14_ = ruler_tick;
		line = page_view_page_to_screen_x (self, _tmp14_) + 0.5;
		_tmp15_ = big_ruler_tick;
		if (_tmp15_ == 5) {
			gdouble _tmp16_;
			gdouble _tmp17_;
			gint _tmp18_;
			gdouble _tmp19_;
			gint _tmp20_;
			gdouble _tmp21_;
			gint _tmp22_;
			gint _tmp23_;
			_tmp16_ = line;
			cairo_move_to (context, _tmp16_, (gdouble) 0);
			_tmp17_ = line;
			_tmp18_ = self->priv->ruler_width;
			cairo_line_to (context, _tmp17_, (gdouble) (-_tmp18_));
			_tmp19_ = line;
			_tmp20_ = h;
			cairo_move_to (context, _tmp19_, (gdouble) _tmp20_);
			_tmp21_ = line;
			_tmp22_ = h;
			_tmp23_ = self->priv->ruler_width;
			cairo_line_to (context, _tmp21_, (gdouble) (_tmp22_ + _tmp23_));
			big_ruler_tick = 0;
		} else {
			gdouble _tmp24_;
			gdouble _tmp25_;
			gdouble _tmp26_;
			gint _tmp27_;
			gdouble _tmp28_;
			gint _tmp29_;
			_tmp24_ = line;
			cairo_move_to (context, _tmp24_, (gdouble) -2);
			_tmp25_ = line;
			cairo_line_to (context, _tmp25_, (gdouble) -5);
			_tmp26_ = line;
			_tmp27_ = h;
			cairo_move_to (context, _tmp26_, (gdouble) (_tmp27_ + 2));
			_tmp28_ = line;
			_tmp29_ = h;
			cairo_line_to (context, _tmp28_, (gdouble) (_tmp29_ + 5));
		}
		_tmp30_ = ruler_tick;
		_tmp31_ = self->priv->_page;
		_tmp32_ = page_get_dpi (_tmp31_);
		_tmp33_ = _tmp32_;
		ruler_tick = _tmp30_ + (_tmp33_ / 5);
		_tmp34_ = big_ruler_tick;
		big_ruler_tick = _tmp34_ + 1;
	}
	cairo_stroke (context);
	ruler_tick = 0;
	line = 0.0;
	big_ruler_tick = 5;
	while (TRUE) {
		gint _tmp35_;
		Page* _tmp36_;
		gint _tmp37_;
		gint _tmp38_;
		gint _tmp39_;
		gint _tmp40_;
		gint _tmp55_;
		Page* _tmp56_;
		gint _tmp57_;
		gint _tmp58_;
		gint _tmp59_;
		_tmp35_ = ruler_tick;
		_tmp36_ = self->priv->_page;
		_tmp37_ = page_get_height (_tmp36_);
		_tmp38_ = _tmp37_;
		if (!(_tmp35_ <= _tmp38_)) {
			break;
		}
		_tmp39_ = ruler_tick;
		line = page_view_page_to_screen_y (self, _tmp39_) + 0.5;
		_tmp40_ = big_ruler_tick;
		if (_tmp40_ == 5) {
			gdouble _tmp41_;
			gint _tmp42_;
			gdouble _tmp43_;
			gint _tmp44_;
			gdouble _tmp45_;
			gint _tmp46_;
			gint _tmp47_;
			gdouble _tmp48_;
			_tmp41_ = line;
			cairo_move_to (context, (gdouble) 0, _tmp41_);
			_tmp42_ = self->priv->ruler_width;
			_tmp43_ = line;
			cairo_line_to (context, (gdouble) (-_tmp42_), _tmp43_);
			_tmp44_ = w;
			_tmp45_ = line;
			cairo_move_to (context, (gdouble) _tmp44_, _tmp45_);
			_tmp46_ = w;
			_tmp47_ = self->priv->ruler_width;
			_tmp48_ = line;
			cairo_line_to (context, (gdouble) (_tmp46_ + _tmp47_), _tmp48_);
			big_ruler_tick = 0;
		} else {
			gdouble _tmp49_;
			gdouble _tmp50_;
			gint _tmp51_;
			gdouble _tmp52_;
			gint _tmp53_;
			gdouble _tmp54_;
			_tmp49_ = line;
			cairo_move_to (context, (gdouble) -2, _tmp49_);
			_tmp50_ = line;
			cairo_line_to (context, (gdouble) -5, _tmp50_);
			_tmp51_ = w;
			_tmp52_ = line;
			cairo_move_to (context, (gdouble) (_tmp51_ + 2), _tmp52_);
			_tmp53_ = w;
			_tmp54_ = line;
			cairo_line_to (context, (gdouble) (_tmp53_ + 5), _tmp54_);
		}
		_tmp55_ = ruler_tick;
		_tmp56_ = self->priv->_page;
		_tmp57_ = page_get_dpi (_tmp56_);
		_tmp58_ = _tmp57_;
		ruler_tick = _tmp55_ + (_tmp58_ / 5);
		_tmp59_ = big_ruler_tick;
		big_ruler_tick = _tmp59_ + 1;
	}
	cairo_stroke (context);
	_tmp61_ = self->priv->_page;
	_tmp62_ = page_get_is_scanning (_tmp61_);
	_tmp63_ = _tmp62_;
	if (_tmp63_) {
		Page* _tmp64_;
		gint _tmp65_;
		gint _tmp66_;
		_tmp64_ = self->priv->_page;
		_tmp65_ = page_get_scan_line (_tmp64_);
		_tmp66_ = _tmp65_;
		_tmp60_ = _tmp66_ > 0;
	} else {
		_tmp60_ = FALSE;
	}
	if (_tmp60_) {
		gint scan_line = 0;
		Page* _tmp67_;
		gint _tmp68_;
		gint _tmp69_;
		gdouble s = 0.0;
		gdouble x1 = 0.0;
		gdouble y1 = 0.0;
		gdouble x2 = 0.0;
		gdouble y2 = 0.0;
		Page* _tmp70_;
		ScanDirection _tmp71_;
		ScanDirection _tmp72_;
		gdouble _tmp96_;
		gdouble _tmp97_;
		gdouble _tmp98_;
		gdouble _tmp99_;
		_tmp67_ = self->priv->_page;
		_tmp68_ = page_get_scan_line (_tmp67_);
		_tmp69_ = _tmp68_;
		scan_line = _tmp69_;
		_tmp70_ = self->priv->_page;
		_tmp71_ = page_get_scan_direction (_tmp70_);
		_tmp72_ = _tmp71_;
		switch (_tmp72_) {
			case SCAN_DIRECTION_TOP_TO_BOTTOM:
			{
				gint _tmp73_;
				gdouble _tmp74_;
				gint _tmp75_;
				gdouble _tmp76_;
				_tmp73_ = scan_line;
				s = (gdouble) page_view_page_to_screen_y (self, _tmp73_);
				x1 = (gdouble) 0;
				_tmp74_ = s;
				y1 = _tmp74_ + 0.5;
				_tmp75_ = w;
				x2 = (gdouble) _tmp75_;
				_tmp76_ = s;
				y2 = _tmp76_ + 0.5;
				break;
			}
			case SCAN_DIRECTION_BOTTOM_TO_TOP:
			{
				gint _tmp77_;
				gint _tmp78_;
				gdouble _tmp79_;
				gint _tmp80_;
				gint _tmp81_;
				gdouble _tmp82_;
				_tmp77_ = scan_line;
				s = (gdouble) page_view_page_to_screen_y (self, _tmp77_);
				x1 = (gdouble) 0;
				_tmp78_ = h;
				_tmp79_ = s;
				y1 = (_tmp78_ - _tmp79_) + 0.5;
				_tmp80_ = w;
				x2 = (gdouble) _tmp80_;
				_tmp81_ = h;
				_tmp82_ = s;
				y2 = (_tmp81_ - _tmp82_) + 0.5;
				break;
			}
			case SCAN_DIRECTION_LEFT_TO_RIGHT:
			{
				gint _tmp83_;
				gdouble _tmp84_;
				gdouble _tmp85_;
				gint _tmp86_;
				_tmp83_ = scan_line;
				s = (gdouble) page_view_page_to_screen_x (self, _tmp83_);
				_tmp84_ = s;
				x1 = _tmp84_ + 0.5;
				y1 = (gdouble) 0;
				_tmp85_ = s;
				x2 = _tmp85_ + 0.5;
				_tmp86_ = h;
				y2 = (gdouble) _tmp86_;
				break;
			}
			case SCAN_DIRECTION_RIGHT_TO_LEFT:
			{
				gint _tmp87_;
				gint _tmp88_;
				gdouble _tmp89_;
				gint _tmp90_;
				gdouble _tmp91_;
				gint _tmp92_;
				_tmp87_ = scan_line;
				s = (gdouble) page_view_page_to_screen_x (self, _tmp87_);
				_tmp88_ = w;
				_tmp89_ = s;
				x1 = (_tmp88_ - _tmp89_) + 0.5;
				y1 = (gdouble) 0;
				_tmp90_ = w;
				_tmp91_ = s;
				x2 = (_tmp90_ - _tmp91_) + 0.5;
				_tmp92_ = h;
				y2 = (gdouble) _tmp92_;
				break;
			}
			default:
			{
				gdouble _tmp93_;
				gdouble _tmp94_;
				gdouble _tmp95_;
				y2 = (gdouble) 0;
				_tmp93_ = y2;
				x2 = _tmp93_;
				_tmp94_ = x2;
				y1 = _tmp94_;
				_tmp95_ = y1;
				x1 = _tmp95_;
				break;
			}
		}
		_tmp96_ = x1;
		_tmp97_ = y1;
		cairo_move_to (context, _tmp96_, _tmp97_);
		_tmp98_ = x2;
		_tmp99_ = y2;
		cairo_line_to (context, _tmp98_, _tmp99_);
		cairo_set_source_rgb (context, 1.0, 0.0, 0.0);
		cairo_stroke (context);
	}
	_tmp100_ = self->priv->_page;
	_tmp101_ = page_get_has_crop (_tmp100_);
	_tmp102_ = _tmp101_;
	if (_tmp102_) {
		gint x = 0;
		Page* _tmp103_;
		gint _tmp104_;
		gint _tmp105_;
		gint y = 0;
		Page* _tmp106_;
		gint _tmp107_;
		gint _tmp108_;
		gint crop_width = 0;
		Page* _tmp109_;
		gint _tmp110_;
		gint _tmp111_;
		gint crop_height = 0;
		Page* _tmp112_;
		gint _tmp113_;
		gint _tmp114_;
		gint dx = 0;
		gint _tmp115_;
		gint dy = 0;
		gint _tmp116_;
		gint dw = 0;
		gint _tmp117_;
		gint dh = 0;
		gint _tmp118_;
		gint _tmp119_;
		gint _tmp120_;
		gint _tmp121_;
		gint _tmp122_;
		gint _tmp123_;
		gint _tmp124_;
		gint _tmp125_;
		gint _tmp126_;
		gint _tmp127_;
		gint _tmp128_;
		gint _tmp129_;
		gint _tmp130_;
		gint _tmp131_;
		gint _tmp132_;
		gint _tmp133_;
		gint _tmp134_;
		gint _tmp135_;
		gint _tmp136_;
		gint _tmp137_;
		gint _tmp138_;
		gint _tmp139_;
		gint _tmp140_;
		gint _tmp141_;
		gint _tmp142_;
		gint _tmp143_;
		gint _tmp144_;
		gint _tmp145_;
		gint _tmp146_;
		gint _tmp147_;
		gint _tmp148_;
		gint _tmp149_;
		gint _tmp150_;
		gint _tmp151_;
		gint _tmp152_;
		_tmp103_ = self->priv->_page;
		_tmp104_ = page_get_crop_x (_tmp103_);
		_tmp105_ = _tmp104_;
		x = _tmp105_;
		_tmp106_ = self->priv->_page;
		_tmp107_ = page_get_crop_y (_tmp106_);
		_tmp108_ = _tmp107_;
		y = _tmp108_;
		_tmp109_ = self->priv->_page;
		_tmp110_ = page_get_crop_width (_tmp109_);
		_tmp111_ = _tmp110_;
		crop_width = _tmp111_;
		_tmp112_ = self->priv->_page;
		_tmp113_ = page_get_crop_height (_tmp112_);
		_tmp114_ = _tmp113_;
		crop_height = _tmp114_;
		_tmp115_ = x;
		dx = page_view_page_to_screen_x (self, _tmp115_);
		_tmp116_ = y;
		dy = page_view_page_to_screen_y (self, _tmp116_);
		_tmp117_ = crop_width;
		dw = page_view_page_to_screen_x (self, _tmp117_);
		_tmp118_ = crop_height;
		dh = page_view_page_to_screen_y (self, _tmp118_);
		_tmp119_ = w;
		_tmp120_ = h;
		cairo_rectangle (context, (gdouble) 0, (gdouble) 0, (gdouble) _tmp119_, (gdouble) _tmp120_);
		cairo_new_sub_path (context);
		_tmp121_ = dx;
		_tmp122_ = dy;
		_tmp123_ = dw;
		_tmp124_ = dh;
		cairo_rectangle (context, (gdouble) _tmp121_, (gdouble) _tmp122_, (gdouble) _tmp123_, (gdouble) _tmp124_);
		cairo_set_fill_rule (context, CAIRO_FILL_RULE_EVEN_ODD);
		cairo_set_source_rgba (context, 0.25, 0.25, 0.25, 0.2);
		cairo_fill (context);
		cairo_set_source_rgb (context, 1.0, 1.0, 1.0);
		_tmp125_ = self->priv->border_width;
		_tmp126_ = dy;
		cairo_move_to (context, (gdouble) (-_tmp125_), _tmp126_ - 1.5);
		_tmp127_ = self->priv->border_width;
		_tmp128_ = w;
		_tmp129_ = dy;
		cairo_line_to (context, (gdouble) (_tmp127_ + _tmp128_), _tmp129_ - 1.5);
		_tmp130_ = self->priv->border_width;
		_tmp131_ = dy;
		_tmp132_ = dh;
		cairo_move_to (context, (gdouble) (-_tmp130_), (_tmp131_ + _tmp132_) + 1.5);
		_tmp133_ = self->priv->border_width;
		_tmp134_ = w;
		_tmp135_ = dy;
		_tmp136_ = dh;
		cairo_line_to (context, (gdouble) (_tmp133_ + _tmp134_), (_tmp135_ + _tmp136_) + 1.5);
		cairo_stroke (context);
		_tmp137_ = dx;
		_tmp138_ = self->priv->border_width;
		cairo_move_to (context, _tmp137_ - 1.5, (gdouble) (-_tmp138_));
		_tmp139_ = dx;
		_tmp140_ = self->priv->border_width;
		_tmp141_ = h;
		cairo_line_to (context, _tmp139_ - 1.5, (gdouble) (_tmp140_ + _tmp141_));
		_tmp142_ = dx;
		_tmp143_ = dw;
		_tmp144_ = self->priv->border_width;
		cairo_move_to (context, (_tmp142_ + _tmp143_) + 1.5, (gdouble) (-_tmp144_));
		_tmp145_ = dx;
		_tmp146_ = dw;
		_tmp147_ = self->priv->border_width;
		_tmp148_ = h;
		cairo_line_to (context, (_tmp145_ + _tmp146_) + 1.5, (gdouble) (_tmp147_ + _tmp148_));
		cairo_stroke (context);
		_tmp149_ = dx;
		_tmp150_ = dy;
		_tmp151_ = dw;
		_tmp152_ = dh;
		cairo_rectangle (context, _tmp149_ - 0.5, _tmp150_ - 0.5, (gdouble) (_tmp151_ + 1), (gdouble) (_tmp152_ + 1));
		cairo_set_source_rgb (context, 0.0, 0.0, 0.0);
		cairo_stroke (context);
	}
}


static void
page_view_page_pixels_changed_cb (PageView* self,
                                  Page* p)
{
	g_return_if_fail (self != NULL);
	g_return_if_fail (p != NULL);
	self->priv->update_image = TRUE;
	g_signal_emit (self, page_view_signals[PAGE_VIEW_CHANGED_SIGNAL], 0);
}


static void
page_view_page_size_changed_cb (PageView* self,
                                Page* p)
{
	g_return_if_fail (self != NULL);
	g_return_if_fail (p != NULL);
	self->priv->update_image = TRUE;
	g_signal_emit (self, page_view_signals[PAGE_VIEW_SIZE_CHANGED_SIGNAL], 0);
	g_signal_emit (self, page_view_signals[PAGE_VIEW_CHANGED_SIGNAL], 0);
}


static void
page_view_page_overlay_changed_cb (PageView* self,
                                   Page* p)
{
	g_return_if_fail (self != NULL);
	g_return_if_fail (p != NULL);
	g_signal_emit (self, page_view_signals[PAGE_VIEW_CHANGED_SIGNAL], 0);
}


static void
page_view_scan_direction_changed_cb (PageView* self,
                                     Page* p)
{
	g_return_if_fail (self != NULL);
	g_return_if_fail (p != NULL);
	self->priv->update_image = TRUE;
	g_signal_emit (self, page_view_signals[PAGE_VIEW_SIZE_CHANGED_SIGNAL], 0);
	g_signal_emit (self, page_view_signals[PAGE_VIEW_CHANGED_SIGNAL], 0);
}


Page*
page_view_get_page (PageView* self)
{
	Page* result;
	Page* _tmp0_;
	g_return_val_if_fail (self != NULL, NULL);
	_tmp0_ = self->priv->_page;
	result = _tmp0_;
	return result;
}


static gpointer
_g_object_ref0 (gpointer self)
{
	return self ? g_object_ref (self) : NULL;
}


static void
page_view_set_page (PageView* self,
                    Page* value)
{
	g_return_if_fail (self != NULL);
	if (page_view_get_page (self) != value) {
		Page* _tmp0_;
		_tmp0_ = _g_object_ref0 (value);
		_g_object_unref0 (self->priv->_page);
		self->priv->_page = _tmp0_;
		g_object_notify_by_pspec ((GObject *) self, page_view_properties[PAGE_VIEW_PAGE_PROPERTY]);
	}
}


gboolean
page_view_get_selected (PageView* self)
{
	gboolean result;
	gboolean _tmp0_;
	g_return_val_if_fail (self != NULL, FALSE);
	_tmp0_ = self->priv->selected_;
	result = _tmp0_;
	return result;
}


void
page_view_set_selected (PageView* self,
                        gboolean value)
{
	gboolean _tmp0_ = FALSE;
	gboolean _tmp1_ = FALSE;
	gboolean _tmp2_;
	gboolean _tmp3_;
	gboolean _tmp11_;
	gboolean _tmp12_;
	g_return_if_fail (self != NULL);
	_tmp2_ = page_view_get_selected (self);
	_tmp3_ = _tmp2_;
	if (_tmp3_) {
		gboolean _tmp4_;
		gboolean _tmp5_;
		_tmp4_ = page_view_get_selected (self);
		_tmp5_ = _tmp4_;
		_tmp1_ = _tmp5_;
	} else {
		_tmp1_ = FALSE;
	}
	if (_tmp1_) {
		_tmp0_ = TRUE;
	} else {
		gboolean _tmp6_ = FALSE;
		gboolean _tmp7_;
		gboolean _tmp8_;
		_tmp7_ = page_view_get_selected (self);
		_tmp8_ = _tmp7_;
		if (!_tmp8_) {
			gboolean _tmp9_;
			gboolean _tmp10_;
			_tmp9_ = page_view_get_selected (self);
			_tmp10_ = _tmp9_;
			_tmp6_ = !_tmp10_;
		} else {
			_tmp6_ = FALSE;
		}
		_tmp0_ = _tmp6_;
	}
	if (_tmp0_) {
		return;
	}
	_tmp11_ = page_view_get_selected (self);
	_tmp12_ = _tmp11_;
	page_view_set_selected (self, _tmp12_);
	g_signal_emit (self, page_view_signals[PAGE_VIEW_CHANGED_SIGNAL], 0);
	g_object_notify_by_pspec ((GObject *) self, page_view_properties[PAGE_VIEW_SELECTED_PROPERTY]);
}


gint
page_view_get_x_offset (PageView* self)
{
	gint result;
	gint _tmp0_;
	g_return_val_if_fail (self != NULL, 0);
	_tmp0_ = self->priv->_x_offset;
	result = _tmp0_;
	return result;
}


void
page_view_set_x_offset (PageView* self,
                        gint value)
{
	g_return_if_fail (self != NULL);
	if (page_view_get_x_offset (self) != value) {
		self->priv->_x_offset = value;
		g_object_notify_by_pspec ((GObject *) self, page_view_properties[PAGE_VIEW_X_OFFSET_PROPERTY]);
	}
}


gint
page_view_get_y_offset (PageView* self)
{
	gint result;
	gint _tmp0_;
	g_return_val_if_fail (self != NULL, 0);
	_tmp0_ = self->priv->_y_offset;
	result = _tmp0_;
	return result;
}


void
page_view_set_y_offset (PageView* self,
                        gint value)
{
	g_return_if_fail (self != NULL);
	if (page_view_get_y_offset (self) != value) {
		self->priv->_y_offset = value;
		g_object_notify_by_pspec ((GObject *) self, page_view_properties[PAGE_VIEW_Y_OFFSET_PROPERTY]);
	}
}


GdkCursorType
page_view_get_cursor (PageView* self)
{
	GdkCursorType result;
	GdkCursorType _tmp0_;
	g_return_val_if_fail (self != NULL, 0);
	_tmp0_ = self->priv->_cursor;
	result = _tmp0_;
	return result;
}


static void
page_view_set_cursor (PageView* self,
                      GdkCursorType value)
{
	g_return_if_fail (self != NULL);
	if (page_view_get_cursor (self) != value) {
		self->priv->_cursor = value;
		g_object_notify_by_pspec ((GObject *) self, page_view_properties[PAGE_VIEW_CURSOR_PROPERTY]);
	}
}


gint
page_view_get_width (PageView* self)
{
	gint result;
	gint _tmp0_;
	g_return_val_if_fail (self != NULL, 0);
	_tmp0_ = self->priv->width_;
	result = _tmp0_;
	return result;
}


void
page_view_set_width (PageView* self,
                     gint value)
{
	gint h = 0;
	Page* _tmp0_;
	gint _tmp1_;
	gint _tmp2_;
	Page* _tmp3_;
	gint _tmp4_;
	gint _tmp5_;
	gboolean _tmp6_ = FALSE;
	gint _tmp7_;
	gint _tmp10_;
	g_return_if_fail (self != NULL);
	_tmp0_ = self->priv->_page;
	_tmp1_ = page_get_height (_tmp0_);
	_tmp2_ = _tmp1_;
	_tmp3_ = self->priv->_page;
	_tmp4_ = page_get_width (_tmp3_);
	_tmp5_ = _tmp4_;
	h = (gint) ((((gdouble) value) * _tmp2_) / _tmp5_);
	_tmp7_ = self->priv->width_;
	if (_tmp7_ == value) {
		gint _tmp8_;
		gint _tmp9_;
		_tmp8_ = self->priv->height_;
		_tmp9_ = h;
		_tmp6_ = _tmp8_ == _tmp9_;
	} else {
		_tmp6_ = FALSE;
	}
	if (_tmp6_) {
		return;
	}
	self->priv->width_ = value;
	_tmp10_ = h;
	self->priv->height_ = _tmp10_;
	self->priv->update_image = TRUE;
	g_signal_emit (self, page_view_signals[PAGE_VIEW_SIZE_CHANGED_SIGNAL], 0);
	g_signal_emit (self, page_view_signals[PAGE_VIEW_CHANGED_SIGNAL], 0);
	g_object_notify_by_pspec ((GObject *) self, page_view_properties[PAGE_VIEW_WIDTH_PROPERTY]);
}


gint
page_view_get_height (PageView* self)
{
	gint result;
	gint _tmp0_;
	g_return_val_if_fail (self != NULL, 0);
	_tmp0_ = self->priv->height_;
	result = _tmp0_;
	return result;
}


void
page_view_set_height (PageView* self,
                      gint value)
{
	gint w = 0;
	Page* _tmp0_;
	gint _tmp1_;
	gint _tmp2_;
	Page* _tmp3_;
	gint _tmp4_;
	gint _tmp5_;
	gboolean _tmp6_ = FALSE;
	gint _tmp7_;
	gint _tmp8_;
	gint _tmp10_;
	g_return_if_fail (self != NULL);
	_tmp0_ = self->priv->_page;
	_tmp1_ = page_get_width (_tmp0_);
	_tmp2_ = _tmp1_;
	_tmp3_ = self->priv->_page;
	_tmp4_ = page_get_height (_tmp3_);
	_tmp5_ = _tmp4_;
	w = (gint) ((((gdouble) value) * _tmp2_) / _tmp5_);
	_tmp7_ = self->priv->width_;
	_tmp8_ = w;
	if (_tmp7_ == _tmp8_) {
		gint _tmp9_;
		_tmp9_ = self->priv->height_;
		_tmp6_ = _tmp9_ == value;
	} else {
		_tmp6_ = FALSE;
	}
	if (_tmp6_) {
		return;
	}
	_tmp10_ = w;
	self->priv->width_ = _tmp10_;
	self->priv->height_ = value;
	self->priv->update_image = TRUE;
	g_signal_emit (self, page_view_signals[PAGE_VIEW_SIZE_CHANGED_SIGNAL], 0);
	g_signal_emit (self, page_view_signals[PAGE_VIEW_CHANGED_SIGNAL], 0);
	g_object_notify_by_pspec ((GObject *) self, page_view_properties[PAGE_VIEW_HEIGHT_PROPERTY]);
}


static void
page_view_class_init (PageViewClass * klass)
{
	page_view_parent_class = g_type_class_peek_parent (klass);
	g_type_class_add_private (klass, sizeof (PageViewPrivate));
	G_OBJECT_CLASS (klass)->get_property = _vala_page_view_get_property;
	G_OBJECT_CLASS (klass)->set_property = _vala_page_view_set_property;
	G_OBJECT_CLASS (klass)->finalize = page_view_finalize;
	g_object_class_install_property (G_OBJECT_CLASS (klass), PAGE_VIEW_PAGE_PROPERTY, page_view_properties[PAGE_VIEW_PAGE_PROPERTY] = g_param_spec_object ("page", "page", "page", TYPE_PAGE, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE));
	g_object_class_install_property (G_OBJECT_CLASS (klass), PAGE_VIEW_SELECTED_PROPERTY, page_view_properties[PAGE_VIEW_SELECTED_PROPERTY] = g_param_spec_boolean ("selected", "selected", "selected", FALSE, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE));
	g_object_class_install_property (G_OBJECT_CLASS (klass), PAGE_VIEW_X_OFFSET_PROPERTY, page_view_properties[PAGE_VIEW_X_OFFSET_PROPERTY] = g_param_spec_int ("x-offset", "x-offset", "x-offset", G_MININT, G_MAXINT, 0, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE));
	g_object_class_install_property (G_OBJECT_CLASS (klass), PAGE_VIEW_Y_OFFSET_PROPERTY, page_view_properties[PAGE_VIEW_Y_OFFSET_PROPERTY] = g_param_spec_int ("y-offset", "y-offset", "y-offset", G_MININT, G_MAXINT, 0, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE));
	g_object_class_install_property (G_OBJECT_CLASS (klass), PAGE_VIEW_CURSOR_PROPERTY, page_view_properties[PAGE_VIEW_CURSOR_PROPERTY] = g_param_spec_enum ("cursor", "cursor", "cursor", gdk_cursor_type_get_type (), GDK_ARROW, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE));
	g_object_class_install_property (G_OBJECT_CLASS (klass), PAGE_VIEW_WIDTH_PROPERTY, page_view_properties[PAGE_VIEW_WIDTH_PROPERTY] = g_param_spec_int ("width", "width", "width", G_MININT, G_MAXINT, 0, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE));
	g_object_class_install_property (G_OBJECT_CLASS (klass), PAGE_VIEW_HEIGHT_PROPERTY, page_view_properties[PAGE_VIEW_HEIGHT_PROPERTY] = g_param_spec_int ("height", "height", "height", G_MININT, G_MAXINT, 0, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE));
	page_view_signals[PAGE_VIEW_SIZE_CHANGED_SIGNAL] = g_signal_new ("size-changed", TYPE_PAGE_VIEW, G_SIGNAL_RUN_LAST, 0, NULL, NULL, g_cclosure_marshal_VOID__VOID, G_TYPE_NONE, 0);
	page_view_signals[PAGE_VIEW_CHANGED_SIGNAL] = g_signal_new ("changed", TYPE_PAGE_VIEW, G_SIGNAL_RUN_LAST, 0, NULL, NULL, g_cclosure_marshal_VOID__VOID, G_TYPE_NONE, 0);
}


static void
page_view_instance_init (PageView * self)
{
	self->priv = PAGE_VIEW_GET_PRIVATE (self);
	self->priv->image = NULL;
	self->priv->selected_ = FALSE;
	self->priv->ruler_width = 8;
	self->priv->border_width = 2;
	self->priv->update_image = TRUE;
	self->priv->_cursor = GDK_ARROW;
	self->priv->animate_n_segments = 7;
}


static void
page_view_finalize (GObject * obj)
{
	PageView * self;
	Page* _tmp0_;
	guint _tmp1_;
	Page* _tmp2_;
	guint _tmp3_;
	Page* _tmp4_;
	guint _tmp5_;
	Page* _tmp6_;
	guint _tmp7_;
	Page* _tmp8_;
	guint _tmp9_;
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, TYPE_PAGE_VIEW, PageView);
	_tmp0_ = self->priv->_page;
	g_signal_parse_name ("pixels-changed", TYPE_PAGE, &_tmp1_, NULL, FALSE);
	g_signal_handlers_disconnect_matched (_tmp0_, G_SIGNAL_MATCH_ID | G_SIGNAL_MATCH_FUNC | G_SIGNAL_MATCH_DATA, _tmp1_, 0, NULL, (GCallback) _page_view_page_pixels_changed_cb_page_pixels_changed, self);
	_tmp2_ = self->priv->_page;
	g_signal_parse_name ("size-changed", TYPE_PAGE, &_tmp3_, NULL, FALSE);
	g_signal_handlers_disconnect_matched (_tmp2_, G_SIGNAL_MATCH_ID | G_SIGNAL_MATCH_FUNC | G_SIGNAL_MATCH_DATA, _tmp3_, 0, NULL, (GCallback) _page_view_page_size_changed_cb_page_size_changed, self);
	_tmp4_ = self->priv->_page;
	g_signal_parse_name ("crop-changed", TYPE_PAGE, &_tmp5_, NULL, FALSE);
	g_signal_handlers_disconnect_matched (_tmp4_, G_SIGNAL_MATCH_ID | G_SIGNAL_MATCH_FUNC | G_SIGNAL_MATCH_DATA, _tmp5_, 0, NULL, (GCallback) _page_view_page_overlay_changed_cb_page_crop_changed, self);
	_tmp6_ = self->priv->_page;
	g_signal_parse_name ("scan-line-changed", TYPE_PAGE, &_tmp7_, NULL, FALSE);
	g_signal_handlers_disconnect_matched (_tmp6_, G_SIGNAL_MATCH_ID | G_SIGNAL_MATCH_FUNC | G_SIGNAL_MATCH_DATA, _tmp7_, 0, NULL, (GCallback) _page_view_page_overlay_changed_cb_page_scan_line_changed, self);
	_tmp8_ = self->priv->_page;
	g_signal_parse_name ("scan-direction-changed", TYPE_PAGE, &_tmp9_, NULL, FALSE);
	g_signal_handlers_disconnect_matched (_tmp8_, G_SIGNAL_MATCH_ID | G_SIGNAL_MATCH_FUNC | G_SIGNAL_MATCH_DATA, _tmp9_, 0, NULL, (GCallback) _page_view_scan_direction_changed_cb_page_scan_direction_changed, self);
	_g_object_unref0 (self->priv->_page);
	_g_object_unref0 (self->priv->image);
	G_OBJECT_CLASS (page_view_parent_class)->finalize (obj);
}


GType
page_view_get_type (void)
{
	static volatile gsize page_view_type_id__volatile = 0;
	if (g_once_init_enter (&page_view_type_id__volatile)) {
		static const GTypeInfo g_define_type_info = { sizeof (PageViewClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) page_view_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (PageView), 0, (GInstanceInitFunc) page_view_instance_init, NULL };
		GType page_view_type_id;
		page_view_type_id = g_type_register_static (G_TYPE_OBJECT, "PageView", &g_define_type_info, 0);
		g_once_init_leave (&page_view_type_id__volatile, page_view_type_id);
	}
	return page_view_type_id__volatile;
}


static void
_vala_page_view_get_property (GObject * object,
                              guint property_id,
                              GValue * value,
                              GParamSpec * pspec)
{
	PageView * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (object, TYPE_PAGE_VIEW, PageView);
	switch (property_id) {
		case PAGE_VIEW_PAGE_PROPERTY:
		g_value_set_object (value, page_view_get_page (self));
		break;
		case PAGE_VIEW_SELECTED_PROPERTY:
		g_value_set_boolean (value, page_view_get_selected (self));
		break;
		case PAGE_VIEW_X_OFFSET_PROPERTY:
		g_value_set_int (value, page_view_get_x_offset (self));
		break;
		case PAGE_VIEW_Y_OFFSET_PROPERTY:
		g_value_set_int (value, page_view_get_y_offset (self));
		break;
		case PAGE_VIEW_CURSOR_PROPERTY:
		g_value_set_enum (value, page_view_get_cursor (self));
		break;
		case PAGE_VIEW_WIDTH_PROPERTY:
		g_value_set_int (value, page_view_get_width (self));
		break;
		case PAGE_VIEW_HEIGHT_PROPERTY:
		g_value_set_int (value, page_view_get_height (self));
		break;
		default:
		G_OBJECT_WARN_INVALID_PROPERTY_ID (object, property_id, pspec);
		break;
	}
}


static void
_vala_page_view_set_property (GObject * object,
                              guint property_id,
                              const GValue * value,
                              GParamSpec * pspec)
{
	PageView * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (object, TYPE_PAGE_VIEW, PageView);
	switch (property_id) {
		case PAGE_VIEW_PAGE_PROPERTY:
		page_view_set_page (self, g_value_get_object (value));
		break;
		case PAGE_VIEW_SELECTED_PROPERTY:
		page_view_set_selected (self, g_value_get_boolean (value));
		break;
		case PAGE_VIEW_X_OFFSET_PROPERTY:
		page_view_set_x_offset (self, g_value_get_int (value));
		break;
		case PAGE_VIEW_Y_OFFSET_PROPERTY:
		page_view_set_y_offset (self, g_value_get_int (value));
		break;
		case PAGE_VIEW_CURSOR_PROPERTY:
		page_view_set_cursor (self, g_value_get_enum (value));
		break;
		case PAGE_VIEW_WIDTH_PROPERTY:
		page_view_set_width (self, g_value_get_int (value));
		break;
		case PAGE_VIEW_HEIGHT_PROPERTY:
		page_view_set_height (self, g_value_get_int (value));
		break;
		default:
		G_OBJECT_WARN_INVALID_PROPERTY_ID (object, property_id, pspec);
		break;
	}
}



